<?php
/*
 *
 * @(#) $Id: form_linked_select.php,v 1.10 2005/08/11 02:36:41 mlemos Exp $
 *
 */

class form_linked_select_class extends form_custom_class
{
	var $select="";
	var $group="";
	var $switch_group="";
	var $linked_input="";
	var $selected_group="";
	var $groups=array();
	var $server_validate=0;

	Function AddInput(&$form, $arguments)
	{
		if(!IsSet($arguments["Groups"])
		|| GetType($arguments["Groups"])!="array")
			return("it were not specified the groups of options");
		if(!IsSet($arguments["LinkedInput"]))
			return("it was not specified a valid input to link the select input");
		$this->groups=$arguments["Groups"];
		$this->linked_input=$arguments["LinkedInput"];
		$this->selected_group=$form->GetInputValue($this->linked_input);
		if(!IsSet($this->groups[$this->selected_group]))
			return("the current linked input value does not match any of the select options groups");
		if(!IsSet($this->groups[$this->selected_group]))
		{
			if((!IsSet($arguments["Group"])
			|| !IsSet($arguments["Groups"][$arguments["Group"]])))
				return("it was not specified a valid group for the current options");
			$this->selected_group=$arguments["Group"];
		}
		$select_arguments=$arguments;
		$this->select=$this->GenerateInputID($form, $this->input, "select");
		$this->group=$this->GenerateInputID($form, $this->input, "group");
		$this->switch_group=$this->GenerateInputID($form, $this->input, "switch_group");
		$select_arguments["NAME"]=$select_arguments["ID"]=$this->focus_input=$this->select;
		$select_arguments["TYPE"]="select";
		$select_arguments["OPTIONS"]=$this->groups[$this->selected_group];
		$select_arguments["DiscardInvalidValues"]=0;
		UnSet($select_arguments["CustomClass"]);
		UnSet($select_arguments["Groups"]);
		UnSet($select_arguments["Group"]);
		if(IsSet($arguments["AutoWidthLimit"])
		|| IsSet($arguments["AutoHeightLimit"]))
		{
			$w=$h=0;
			Reset($this->groups);
			for($g=0;$g<count($this->groups);$g++)
			{
  			$group=Key($this->groups);
				Reset($this->groups[$group]);
				for($o=0;$o<count($this->groups[$group]);$o++)
				{
					$option=Key($this->groups[$group]);
					$w=max($w,strlen($this->groups[$group][$option]));
					Next($this->groups[$group]);
				}
				$h=max($h,$o);
				Next($this->groups);
		}
			if(IsSet($arguments["AutoWidthLimit"]))
			{
				if($arguments["AutoWidthLimit"]>0)
					$w=min($w+1,$arguments["AutoWidthLimit"]);
				$select_arguments["STYLE"]="width: ".strval($w)."em".(IsSet($arguments["STYLE"]) ? "; ".$arguments["STYLE"] : "");
			}
			if(IsSet($arguments["AutoHeightLimit"]))
			{
				if($arguments["AutoHeightLimit"]>0)
					$h=min($h,$arguments["AutoHeightLimit"]);
				$select_arguments["SIZE"]=strval($h);
			}
		}
		if(strlen($error=$form->AddInput($select_arguments))==0
		&& strlen($form->AddInput(array(
			"TYPE"=>"hidden",
			"ID"=>$this->group,
			"NAME"=>$this->group,
			"VALUE"=>$this->selected_group
		)))==0)
			$error=$form->Connect($this->linked_input, $this->input, "ONCHANGE", "SwitchGroup", array("GroupProperty"=>"VALUE"));
		return($error);
	}

	Function AddInputPart(&$form)
	{
		if(strlen($error=$form->AddInputPart($this->select))==0
		&& strlen($error=$form->AddInputPart($this->group))==0)
		{
			$eol=$form->end_of_line;
			$javascript="<script type=\"text/javascript\" defer=\"defer\">".$eol."<!--\nfunction ".$this->switch_group."(g,o){";
			Reset($this->groups);
			for($g=0, $append="";$g<count($this->groups); $g++)
			{
				$group=strval(Key($this->groups));
				if($g>0)
					$javascript.="}else{";
				$javascript.="if(g==".$form->EncodeJavascriptString($group)."){n=[";
				$append.="}";
				Reset($this->groups[$group]);
				for($o=0;$o<count($this->groups[$group]);$o++)
				{
  				$option=strval(Key($this->groups[$group]));
					if($o>0)
						$javascript.=",";
					$javascript.=$form->EncodeJavascriptString($this->groups[$group][$option]).",".$form->EncodeJavascriptString($option);
					Next($this->groups[$group]);
  			}
				$javascript.="]";
				Next($this->groups);
			}
			$javascript.="}else{n=null".$append."if(n==null){return false}i=0;while(i<n.length){o[i/2]=new Option(n[i],n[i+1]);i=i+2}while(i<o.length*2){o[i/2]=null}o[0].selected=true;return true";
			$javascript.="}".$eol."// -->".$eol."</script>";
			$error=$form->AddDataPart($javascript);
		}
		return($error);
	}

	Function GetInputValue(&$form)
	{
		return($form->GetInputValue($this->select));
	}

	Function Connect(&$form, $to, $event, $action, &$context)
	{
		return($form->Connect($this->select, $to, $event, $action, $context));
	}

	Function GetJavascriptConnectionAction(&$form, $form_object, $from, $event, $action, &$context, &$javascript)
	{
		switch($action)
		{
			case "SwitchGroup":
				$property=(IsSet($context["GroupProperty"]) ? $context["GroupProperty"] : "VALUE");
				if(strcmp($property, "VALUE"))
					return("it is not supported to switch to a group defined by property ".$property);
				$value=$form->GetJavascriptInputValue($form_object, $from);
				if(strlen($value)==0)
					return("it was not possible to determine how to retrieve ".$property." value");
				$javascript="if(".$this->switch_group."(g=".$value.",".$form_object."[".$form->EncodeJavascriptString($this->select)."].options)){".$form_object."[".$form->EncodeJavascriptString($this->group)."].value=g}";
				break;
			default:
				return($this->DefaultGetJavascriptConnectionAction($form, $form_object, $from, $event, $action, $context, $javascript));
		}
		return("");
	}

	Function LoadInputValues(&$form, $submitted)
	{
		$group=$form->GetInputValue($this->linked_input);
		$selected_group=$form->GetInputValue($this->group);
		if(!IsSet($this->groups[$group]))
			$group=$selected_group;
		if(IsSet($this->groups[$group]))
		{
			$option=$form->GetInputValue($this->select);
			if(IsSet($this->groups[$group][$option]))
				$form->SetSelectOptions($this->select, $this->groups[$this->selected_group=$group], array($option));
			else
			{
				Reset($this->groups[$this->selected_group]);
				$option=Key($this->groups[$this->selected_group]);
				$form->SetInputValue($this->select, $option);
			}
		}
		if(strcmp($group, $selected_group))
			$form->SetInputValue($this->group, $this->selected_group=$group);
	}

};

?>