<?
if(!defined("METAL_DISTRIBUTION_INCLUDED"))
{
	define("METAL_DISTRIBUTION_INCLUDED",1);

/*
 * metal_distribution.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_distribution.php,v 1.12 2001/03/24 22:23:17 mlemos Exp $
 *
 */
 
class metal_distribution_class extends metal_base_class
{
	Function GetAddedFile(&$compiler,&$context,&$code,&$added_file)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "file":
					case "type":
						if(IsSet($added_file[$data["Tag"]]))
						{
							$compiler->SetElementError($context->file,$element_path,"it was specified the distribution add file ".$data["Tag"]." argument more than once");
							return(0);
						}
						if(!$compiler->GetValidData($context->file,$element_path,&$added_file[$data["Tag"]],"it was not specified a valid distribution add file ".$data["Tag"]." argument"))
							return(0);
						switch($data["Tag"])
						{
							case "file":
								if(!file_exists($added_file["file"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was not specified an existing distribution file to add (\"".$added_file["file"]."\")");
									return(0);
								}
								break;
							case "type":
								switch($added_file["type"])
								{
									case "GENERATED":
									case "SUPPLIED":
										break;
									default:
										$compiler->SetElementError($context->file,$element_path,"it was not specified a supported distribution add file type");
										return(0);
								}
								break;
						}
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported distribution object add file argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($function)
		{
			case "pack":
				$files=$pack_arguments=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($pending_data="",$element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "archive":
							case "format":
							case "basepath";
								if(IsSet($pack_arguments[$data["Tag"]]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified the distribution pack ".$data["Tag"]." argument more than once");
									return(0);
								}
								if(!$compiler->GetValidData($context->file,$element_path,&$pack_arguments[$data["Tag"]],"it was not specified a valid distribution pack ".$data["Tag"]." argument"))
									return(0);
								switch($data["Tag"])
								{
									case "format":
										switch($pack_arguments["format"])
										{
											case "tar.gz":
												break;
											default:
												$compiler->SetElementError($context->file,$element_path,"it was not specified a supported distribution pack format");
												return(0);
										}
										break;
									case "basepath":
										if(!($directory=opendir($pack_arguments["basepath"])))
										{
											$compiler->SetElementError($context->file,$element_path,"it was not specified an existing pack base path directory");
											return(0);
										}
										closedir($directory);
										break;
								}
								break;
							case "list":
								if(!$compiler->GetValidData($context->file,$element_path,&$files_filename,"it was not specified a valid distribution pack list file argument"))
									return(0);
								if(!file_exists($files_filename))
								{
									$compiler->SetElementError($context->file,$element_path,"it was not specified an existing distribution pack list file \"$files_filename\"");
									return(0);
								}
								if(!($files_file=fopen($files_filename,"r")))
								{
									$compiler->SetElementError($context->file,$element_path,"it was not possible to open the distribution pack list file \"$files_filename\"");
									return(0);
								}
								if(function_exists("set_file_buffer"))
									set_file_buffer($files_file,0);
								$files_serialized=fread($files_file,filesize($files_filename));
								$closed=fclose($files_file);
								if(!$files_serialized
								|| !$closed)
								{
									$compiler->SetElementError($context->file,$element_path,"it was not possible to read the distribution pack list file \"$files_filename\"");
									return(0);
								}
								if(GetType($files_list=unserialize($files_serialized))!="array")
								{
									$compiler->SetElementError($context->file,$element_path,"it was not specified a valid distribution list files file \"$files_filename\"");
									return(0);
								}
								for($file=0;$file<count($files_list);$file++)
								{
									switch($files_list[$file]["Type"])
									{
										case "GENERATED":
										case "SUPPLIED":
											$file_name=$files_list[$file]["Name"];
											if(!file_exists($file_name))
											{
												$compiler->SetElementError($context->file,$context->path,"it was specified a distribution pack file (\"".$file_name."\") in a LIST file that does exist");
												return(0);
											}
											$files[$file_name]=$files_list[$file]["Type"];
											break;
										case "DEPENDENCY":
											break;
										default:
											$compiler->SetElementError($context->file,$context->path,"it was specified a distribution pack file (\"".$file_name."\") in a LIST file of an unsupported type(\"".$files_list[$file]["Type"]."\")");
											return(0);
									}
								}
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported distribution object pack argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($pack_arguments[$argument="archive"])
				|| !IsSet($pack_arguments[$argument="format"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the distribution pack $argument argument");
					return(0);
				}
				if(count($files)==0)
				{
					$compiler->SetElementError($context->file,$context->path,"it were not specified any files to pack in the distribution archive file");
					return(0);
				}
				ksort($files);
				for($files_list="",$file=0,Reset($files);$file<count($files);Next($files),$file++)
				{
					$file_name=Key($files);
					if(IsSet($pack_arguments["basepath"]))
						$file_name=$compiler->RelativePath($pack_arguments["basepath"],$file_name);
					if($files_list!="")
						$files_list.=" ";
					$files_list.=$file_name;
				}
				$command="tar".(IsSet($pack_arguments["basepath"]) ? " -C ".$pack_arguments["basepath"] : "")." -zcf ".$pack_arguments["archive"]." $files_list";
				Exec($command,$output,$result);
				if($result)
				{
					$compiler->SetElementError($context->file,$context->path,"it was not possible to create the distribution pack archive");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$pack_arguments["archive"],
						"Type"=>"GENERATED"
					),
					"Type"=>"FILE"
				);
				break;
			case "addfile":
				$added_file=array();
				if(!$this->GetAddedFile(&$compiler,&$arguments,&$arguments_code,&$added_file)
				|| !$this->GetAddedFile(&$compiler,&$context,&$code,&$added_file))
					return(0);
				if(!IsSet($added_file["file"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not defined the distribution file to add");
					return(0);
				}
				if(!IsSet($added_file["type"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not defined the type of the distribution file to add");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$added_file["file"],
						"Type"=>$added_file["type"]
					),
					"Type"=>"FILE"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported distribution object function");
				return(0);
		}
		return(1);
	}

};
 
}
?>