<?php
if(!defined("DOCUMENT_INCLUDED"))
{
	define("DOCUMENT_INCLUDED",1);

/*
 * document.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_document.php,v 1.24 2004/08/26 01:01:14 mlemos Exp $
 *
 */
 
class document_class extends metal_base_class
{
	var $document_context="DOCUMENT";
	var $list_level=0;
	var $list_items=array();
	var $lists=0;
	var $tables_of_contents=array();
	var $properties=array();

	Function AddResultDataPart(&$context,$data)
	{
		if(($last=count($context->result)-1)>=0
		&& $context->result[$last]["Type"]=="DATA")
			$context->result[$last]["Data"].=$data;
		else
		{
			$context->result[]=array(
				"Data"=>$data,
				"Type"=>"DATA"
			);
		}
	}

	Function GetPropertyContext(&$compiler,&$arguments,&$arguments_code,&$property,&$document_context,$function,&$immediate)
	{
		$document_context=$this->document_context;
		$immediate=0;
		$property="";
		$elements=$arguments_code->structure[$arguments->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$arguments->path.",$element";
			$data=$arguments_code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "property":
						if(!$compiler->GetValidName($arguments->file,$element_path,$property,"it was not specified a valid document $function property property"))
							return(0);
						break;
					case "context":
						if(!$compiler->GetValidData($arguments->file,$element_path,$new_context,"it was not specified a valid document $function context property"))
							return(0);
						switch($new_context)
						{
							case "DOCUMENT":
							case "HEADER":
							case "BODY":
							case "LIST":
							case "TABLEOFCONTENTS":
							case "MARK":
							case "PARAGRAPH":
								break;
							default:
								$compiler->SetElementError($arguments->file,$element_path,"$new_context is not a valid document $function property context");
								return(0);
						}
						$document_context=$new_context;
						break;
					case "immediate":
						$immediate=1;
						break;
					default:
						$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a valid document $function argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
					return(0);
			}
		}
		if(!strcmp($property,""))
		{
			$compiler->SetElementError($arguments->file,$arguments->path,"it was not specified the document $function property argument");
			return(0);
		}
		return(1);
	}

	Function StripIndentation(&$compiler,&$context,$error)
	{
		$result=array();
		if(!$compiler->GetOutputData($context->file,$context->path,$result,$error,0))
			return(0);
		for($stripping=1,$part=0;$part<count($result);$part++)
		{
			switch($result[$part]["Type"])
			{
				case "DATA":
					if($stripping)
					{
						$stripped=$compiler->StripIndentation($result[$part]["Data"]);
						if(strlen($stripped))
							$this->AddResultDataPart($context,$stripped);
					}
					else
						$this->AddResultDataPart($context,$result[$part]["Data"]);
					break;
				case "EXPRESSION":
					switch($result[$part]["Data"]["Type"])
					{
						case "PREFORMATTED.START":
							$stripping--;
							break;
						case "PREFORMATTED.END":
							$stripping++;
							break;
					}
				default:
					$context->result[]=$result[$part];
					break;
			}
		}
		return(1);
	}

	Function GetTableOfContentsArguments(&$compiler,&$arguments,&$arguments_code,&$values,$function)
	{
		$values=array();
		$elements=$arguments_code->structure[$arguments->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$arguments->path.",$element";
			$data=$arguments_code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "context":
						if(!$compiler->GetValidName($arguments->file,$element_path,$values["context"],"it was not specified a valid document $function context argument"))
							return(0);
						if($function=="tableofcontents"
						&& IsSet($this->tables_of_contents[$values["context"]]))
						{
							$compiler->SetElementError($arguments->file,$element_path,$values["context"]." document tableofcontents context is already defined");
							return(0);
						}
						break;
					case "level":
					case "name":
						if($function=="mark")
						{
							if(!$compiler->GetValidData($arguments->file,$element_path,$values[$data["Tag"]],"it was not specified a valid document $function ".$data["Tag"]." argument"))
								return(0);
							break;
						}
					default:
						$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a valid document $function argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
					return(0);
			}
		}
		if(!IsSet($values[$argument="context"])
		|| ($function=="mark"
		&& (!IsSet($values[$argument="level"])
		|| !IsSet($values[$argument="name"]))))
		{
			$compiler->SetElementError($arguments->file,$arguments->path,"it was not specified the document $function $argument argument");
			return(0);
		}
		return(1);
	}

	Function GetParagraphArguments(&$compiler, &$context, &$arguments, &$paragraph, $function)
	{
		$paragraph=array();
		$paragraph_values=array();
		$required_types=array(
		);
		$optional_types=array(
			"style"=>"CONTEXT"
		);
		if(!$compiler->GetOptionalArgumentValues($arguments,$paragraph_values,$required_types,$optional_types,"document",$function,1))
			return(0);
		if(IsSet($paragraph_values["style"]))
		{
			$required_types=array(
			);
			$optional_types=array(
				"backgroundcolor"=>"DATA",
				"align"=>"DATA"
			);
			if(!$compiler->GetOptionalArgumentValues($paragraph_values["style"],$paragraph["style"],$required_types,$optional_types,"document",$function,1))
				return(0);
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($compiler->language["name"])
		{
			case "PHP":
			case "Java":
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the DOCUMENT class");
				return(0);
		}
		switch($function)
		{
			case "document":
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"DOCUMENT.START"
					),
					"Type"=>"EXPRESSION"
				);
				$document_context=$this->document_context;
				$this->document_context="DOCUMENT";
				if(!$compiler->GetOutputData($context->file,$context->path,$context->result,"invalid document output",1))
					return(0);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"DOCUMENT.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "header":
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"HEADER.START"
					),
					"Type"=>"EXPRESSION"
				);
				$document_context=$this->document_context;
				$this->document_context="HEADER";
				if(!$compiler->GetOutputData($context->file,$context->path,$context->result,"invalid document header output",1))
					return(0);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"HEADER.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "body":
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"BODY.START"
					),
					"Type"=>"EXPRESSION"
				);
				$document_context=$this->document_context;
				$this->document_context="BODY";
				if(!$compiler->GetOutputData($context->file,$context->path,$context->result,"invalid document body output",1))
					return(0);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"BODY.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "paragraph":
				if(!$this->GetParagraphArguments($compiler, $context, $arguments, $paragraph, $function))
					return(0);
				$data=array(
					"Type"=>"PARAGRAPH.START"
				);
				if(IsSet($paragraph["style"])
				&& count($paragraph["style"]))
					$data["Style"]=$paragraph["style"];
				$context->result[]=array(
					"Data"=>$data,
					"Type"=>"EXPRESSION"
				);
				$document_context=$this->document_context;
				$this->document_context="PARAGRAPH";
				if(!$this->StripIndentation($compiler,$context,"invalid document paragraph output"))
					return(0);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"PARAGRAPH.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "preformatted":
				if(!$this->GetParagraphArguments($compiler, $context, $arguments, $paragraph, $function))
					return(0);
				switch($this->document_context)
				{
					case "PARAGRAPH":
						$context->result[]=array(
								"Data"=>array(
								"Type"=>"PARAGRAPH.END"
							),
							"Type"=>"EXPRESSION"
						);
				}
				$data=array(
					"Type"=>"PREFORMATTED.START"
				);
				if(IsSet($paragraph["style"])
				&& count($paragraph["style"]))
					$data["Style"]=$paragraph["style"];
				$context->result[]=array(
					"Data"=>$data,
					"Type"=>"EXPRESSION"
				);
				$document_context=$this->document_context;
				$this->document_context="PREFORMATTED";
				if(!$compiler->GetOutputData($context->file,$context->path,$context->result,"invalid document preformatted output",0))
					return(0);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"PREFORMATTED.END"
					),
					"Type"=>"EXPRESSION"
				);
				switch($this->document_context)
				{
					case "PARAGRAPH":
						$context->result[]=array(
								"Data"=>array(
									"Type"=>"PARAGRAPH.START"
							),
							"Type"=>"EXPRESSION"
						);
				}
				break;
			case "list":
				$this->lists++;
				$this->list_level++;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"LIST.START",
						"Level"=>$this->list_level
					),
					"Type"=>"EXPRESSION"
				);
				$this->list_items[$this->list_level]=0;
				$document_context=$this->document_context;
				$this->document_context="LIST";
				if(!$compiler->GetOutputData($context->file,$context->path,$context->result,"invalid document list output",1))
					return(0);
				Unset($this->list_items[$this->list_level]);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"LIST.END"
					),
					"Type"=>"EXPRESSION"
				);
				$this->list_level--;
				break;
			case "listitem":
				if(!IsSet($this->list_items[$this->list_level]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was specified a listitem outside a list");
					return(0);
				}
				$this->list_items[$this->list_level]++;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"LISTITEM.START",
						"ITEM"=>$this->list_items[$this->list_level]
					),
					"Type"=>"EXPRESSION"
				);
				$document_context=$this->document_context;
				$this->document_context="LISTITEM";
				if(!$this->StripIndentation($compiler,$context,"invalid document listitem output"))
					return(0);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"LISTITEM.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "heading":
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"PARAGRAPH.START",
						"Style"=>array("paragraph"=>"HEADING"),
						"Level"=>$this->list_level+1
					),
					"Type"=>"EXPRESSION"
				);
				$document_context=$this->document_context;
				$this->document_context="HEADING";
				if(!$this->StripIndentation($compiler,$context,"invalid document heading output"))
					return(0);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"PARAGRAPH.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "sectionbreak":
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"SECTIONBREAK"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "paragraphbreak":
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"PARAGRAPHBREAK"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "linebreak":
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"LINEBREAK"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "tableofcontents":
				if(!$this->GetTableOfContentsArguments($compiler,$arguments,$arguments_code,$values,$function))
					return(0);
				if(IsSet($this->tables_of_contents[$values["context"]]))
					$this->tables_of_contents[$values["context"]]++;
				else
					$this->tables_of_contents[$values["context"]]=1;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"TABLEOFCONTENTS.START",
						"Context"=>$values["context"]
					),
					"Type"=>"EXPRESSION"
				);
				$document_context=$this->document_context;
				$this->document_context="TABLEOFCONTENTS";
				if(!$compiler->GetOutputData($context->file,$context->path,$context->result,"invalid document tableofcontents output",0))
					return(0);
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"TABLEOFCONTENTS.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "mark":
				if(!$this->GetTableOfContentsArguments($compiler,$arguments,$arguments_code,$values,$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"MARK.START",
						"Name"=>$values["name"]
					),
					"Type"=>"EXPRESSION"
				);
				$path=$this->lists.".".$this->list_level;
				if(IsSet($this->list_items[$this->list_level]))
					$path.=".".$this->list_items[$this->list_level];
				if(IsSet($this->marks[$path]))
					++$this->marks[$path];
				else
					$this->marks[$path]=0;
				$part=count($context->result);
				$document_context=$this->document_context;
				$this->document_context="MARK";
				if(!$compiler->GetOutputData($context->file,$context->path,$context->result,"invalid document mark output",0))
					return(0);
				if(IsSet($this->tables_of_contents[$values["context"]]))
				{
					$end_part=count($context->result);
					$context->result[]=array(
						"Data"=>array(
							"Type"=>"TABLEOFCONTENTS.ENTRY.START",
							"Context"=>$values["context"],
							"Name"=>$values["name"],
							"Level"=>$values["level"]
						),
						"Type"=>"EXPRESSION"
					);
					$context->result[]=array(
						"Data"=>array(
							"Type"=>"LINK.START",
							"Name"=>$values["name"]
						),
						"Type"=>"EXPRESSION"
					);
					for(;$part<$end_part;$part++)
					{
						switch($context->result[$part]["Type"])
						{
							case "DATA":
								$this->AddResultDataPart($context,$context->result[$part]["Data"]);
								break;
						}
					}
					$context->result[]=array(
						"Data"=>array(
							"Type"=>"LINK.END"
						),
						"Type"=>"EXPRESSION"
					);
					$context->result[]=array(
						"Data"=>array(
							"Type"=>"TABLEOFCONTENTS.ENTRY.END"
						),
						"Type"=>"EXPRESSION"
					);
				}
				$this->document_context=$document_context;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"MARK.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "monospaced":
			case "bold":
			case "italic":
				$style=strtoupper($function);
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"$style.START"
					),
					"Type"=>"EXPRESSION"
				);
				if(!$this->StripIndentation($compiler,$context,"invalid document $function output"))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"$style.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "link":
				$values=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "data":
							case "url":
							case "name":
							case "anchor":
								if(IsSet($values[$data["Tag"]]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified the document link ".$values[$data["Tag"]]."argument more than once");
									return(0);
								}
								if(!$compiler->GetValidData($context->file,$element_path,$values[$data["Tag"]],"it was not specified a valid document link ".$data["Tag"]." argument"))
									return(0);
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a valid document link argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($values["name"])
				&& !IsSet($values["url"])
				&& !IsSet($values["anchor"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified either the link url or anchor name");
					return(0);
				}
				$data=array("Type"=>"LINK.START");
				if(IsSet($values["url"]))
					$data["URL"]=$values["url"];
				if(IsSet($values["name"]))
					$data["Name"]=$values["name"];
				if(IsSet($values["anchor"]))
					$data["Anchor"]=$values["anchor"];
				$context->result[]=array(
					"Data"=>$data,
					"Type"=>"EXPRESSION"
				);
				if(IsSet($values["data"]))
					$this->AddResultDataPart($context,$values["data"]);
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"LINK.END"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "set":
				if(!$this->GetPropertyContext($compiler,$arguments,$arguments_code,$property,$document_context,"SET",$immediate)
				|| !$compiler->GetValidData($context->file,$context->path,$value,"it was not specified a valid document set property value"))
					return(0);
				$this->properties[$document_context][$property]=$value;
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"SET",
						"Context"=>$document_context,
						"Property"=>$property,
						"Value"=>$value
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "get":
				if(!$this->GetPropertyContext($compiler,$arguments,$arguments_code,$property,$document_context,"GET",$immediate))
					return(0);
				if($immediate)
				{
					Unset($value);
					if(IsSet($this->properties[$document_context][$property]))
						$value=$this->properties[$document_context][$property];
					else
					{
						switch($document_context)
						{
							case "LIST":
								switch($property)
								{
									case "LEVEL":
										$value=strval($this->list_level);
										break;
									case "PATH":
										$value=$this->lists.".".$this->list_level;
										if(IsSet($this->list_items[$this->list_level]))
											$value.=".".$this->list_items[$this->list_level];
										if(IsSet($this->marks[$value]))
											$value.=".".$this->marks[$value];
										break;
								}
								break;
						}
					}
					if(!IsSet($value))
					{
						$compiler->SetElementError($context->file,$context->path,$document_context.".".$property." is not a supported immediate document property");
						return(0);
					}
					$this->AddResultDataPart($context,$value);
				}
				else
				{
					$context->result[]=array(
						"Data"=>array(
							"Type"=>"GET",
							"Context"=>$document_context,
							"Property"=>$property
						),
						"Type"=>"EXPRESSION"
					);
				}
				break;
			case "image":
				$values=array(
				);
				$types=array(
					"source"=>"DATA"
				);
				$optional_types=array(
					"alternativetext"=>"DATA"
				);
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"document",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"document",$function,1))
					return(0);
				if(!file_exists($values["source"]))
					return($compiler->SetElementError($context->file,$context->path,"it was not specified an existing image source file"));
				$context->result[]=array(
					"Data"=>array(
						"Type"=>"IMAGE",
						"File"=>$values["source"],
						"AlternativeText"=>$values["alternativetext"]
					),
					"Type"=>"EXPRESSION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$values["source"],
						"Type"=>"DEPENDENCY"
					),
					"Type"=>"FILE"
				);
				break;
			case "extractmetadocument":
				$values=array();
				$types=array(
					"source"=>"DATA",
					"target"=>"DATA"
				);
				$optional_types=array(
				);
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"document",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"document",$function,1))
					return(0);
				if(!file_exists($values["source"]))
					return($compiler->SetElementError($context->file,$context->path,"it was not specified an existing meta-document source file"));
				if(!($source=@fopen($values["source"],"r")))
					return($compiler->SetElementError($context->file,$context->path,"could not open the meta-document source file"));
				if(!($data=@fread($source,filesize($values["source"]))))
					return($compiler->SetElementError($context->file,$context->path,"could not read the meta-document source file"));
				fclose($source);
				if(!($target=@fopen($values["target"],"w")))
					return($compiler->SetElementError($context->file,$context->path,"could not open the meta-document target file"));
				for($sections=0,$position=0;$position<strlen($data);)
				{
					if(GetType($position=strpos($data,"{metadocument}",$position))!="integer")
						break;
					$start=$position+strlen("{metadocument}");
					if(GetType($position=strpos($data,"{/metadocument}",$start))!="integer")
					{
						fclose($target);
						return($compiler->SetElementError($context->file,$context->path,"could not find the end meta-document mark in source file after position ".$start));
					}
					if(!@fwrite($target,substr($data,$start,$position-$start)))
					{
						fclose($target);
						return($compiler->SetElementError($context->file,$context->path,"could not write to the meta-document target file"));
					}
					$sections++;
					$position+=strlen("{/metadocument}");
				}
				fclose($target);
				if($sections==0)
					return($compiler->SetElementError($context->file,$context->path,"the meta-document source file \"".$values["source"]."\" does not have any documentation sections"));
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$values["source"],
						"Type"=>"DEPENDENCY"
					),
					"Type"=>"FILE"
				);
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$values["target"],
						"Type"=>"GENERATED"
					),
					"Type"=>"FILE"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported document object function");
				return(0);
		}
		return(1);
	}

};

}
?>