<?php
if(!defined("METAL_FILE_INCLUDED"))
{
	define("METAL_FILE_INCLUDED",1);

/*
 * metal_file.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_file.php,v 1.17 2004/05/11 02:19:34 mlemos Exp $
 *
 */
 
class metal_file_class extends metal_base_class
{
	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the file class");
			return(0);
		}
		switch($function)
		{
			case "directorypath":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid file directorypath name")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$value,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"dirname($value)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "relativepath":
				$path_arguments=array();
				$immediate=0;
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "from":
							case "to":
								if(IsSet($path_arguments[$data["Tag"]]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was specified the file relativepath ".$data["Tag"]." argument more than once");
									return(0);
								}
								if(!$compiler->GetValidData($context->file,$element_path,$path_arguments[$data["Tag"]],"it was not specified a valid file relativepath ".$data["Tag"]." option"))
									return(0);
								break;
							case "immediate":
								if(!$compiler->GetValidData($context->file,$element_path,$immediate,"it was not specified a valid file relativepath immediate option"))
									return(0);
								if(strcmp($immediate,"1")
								&& strcmp($immediate,"0"))
								{
									$compiler->SetElementError($context->file,$element_path,"it was not specified a valid boolean file relativepath immediate option value");
									return(0);
								}
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported file relativepath argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($path_arguments[$argument="from"])
				|| !IsSet($path_arguments[$argument="to"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the file relativepath $argument argument");
					return(0);
				}
				if(!$immediate)
				{
					$compiler->SetElementError($context->file,$context->path,"the non immediate file relativepath function version is not yet supported");
					return(0);
				}
				$context->result[]=array(
					"Data"=>$compiler->RelativePath($path_arguments["from"],$path_arguments["to"]),
					"Type"=>"DATA"
				);
				break;
			case "basefilename":
				if(!$compiler->GetValidData($context->file,$context->path,$filename,"it was not specified a valid $function filename"))
					return(0);
				$filename=basename($filename);
				if(GetType($dot=strrpos($filename,"."))=="integer")
					$filename=substr($filename,0,$dot);
				$context->result[]=array(
					"Data"=>$filename,
					"Type"=>"DATA"
				);
				break;
			case "opendirectory":
				$types=array(
					"handle"=>"INTEGER:NOTRIGHT",
					"path"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"file",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"((".$values["handle"]."=@opendir(".$values["path"]."))!=0)",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "readdirectory":
				$types=array(
					"handle"=>"INTEGER",
					"entry"=>"STRING:NOTRIGHT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"file",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"GetType(".$values["entry"]."=readdir(".$values["handle"]."))=='string'",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "closedirectory":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"INTEGER","it was not specified a valid directory name to open")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$handle,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>"closedir($handle);",
					"Type"=>"COMMAND"
				);
				break;
			case "isdirectory":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid directory path value")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$path,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"@is_dir($path)",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "filelength":
				$types=array(
					"path"=>"STRING",
					"length"=>"INTEGER:NOTRIGHT"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"file",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"(GetType(".$values["length"]."=@filesize(".$values["path"]."))=='integer')",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "openfilereadmode":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"'rb'",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "openfilewritemode":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"'wb'",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;

			case "openfileappendmode":
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"'ab'",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "openfile":
				$types=array(
					"handle"=>"INTEGER:NOTRIGHT",
					"path"=>"STRING",
					"mode"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"file",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"((".$values["handle"]."=@fopen(".$values["path"].",".$values["mode"]."))!=0)",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "readfile":
				$types=array(
					"handle"=>"INTEGER",
					"data"=>"STRING:NOTRIGHT",
					"datatype"=>"DATA"
				);
				$optional_types=array(
					"length"=>"INTEGER"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"file",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"file",$function,1))
					return(0);
				$needs_length=0;
				switch($values["datatype"])
				{
					case "character":
						$read_function="fgetc";
						break;
					case "line":
						$needs_length=1;
						$read_function="fgets";
						break;
					case "block":
						$needs_length=1;
						$read_function="fread";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$values["datatype"]." is not a supported data type to read from a file");
						return(0);
				}
				if($needs_length
				&& !IsSet($values["length"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the limit of the length of data to read from the file");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"GetType(".$values["data"]."=".$read_function."(".$values["handle"].($needs_length ? ",".$values["length"] : "")."))=='string'",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "writefile":
				$types=array(
					"handle"=>"INTEGER",
					"data"=>"STRING:NOTLEFT",
					"datatype"=>"DATA"
				);
				$optional_types=array(
					"length"=>"INTEGER"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"file",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"file",$function,1))
					return(0);
				$needs_length=0;
				switch($values["datatype"])
				{
					case "character":
						$write_function="fputc";
						break;
					case "line":
						$needs_length=1;
						$write_function="fputs";
						break;
					case "block":
						$needs_length=1;
						$write_function="fwrite";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$values["datatype"]." is not a supported data type write to file");
						return(0);
				}
				if($needs_length
				&& !IsSet($values["length"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the limit of the length of data to write to the file");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"(".$write_function."(".$values["handle"].",".$values["data"].($needs_length ? ",".$values["length"] : "").")!=0)",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "endoffile":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"INTEGER","it was not specified a valid file name to check for end of file condition")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$handle,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"feof($handle)",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "flushfile":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"INTEGER","it was not specified a valid file name to flush")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$handle,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"fflush($handle)",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "closefile":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"INTEGER","it was not specified a valid file name to open")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$handle,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>"fclose($handle);",
					"Type"=>"COMMAND"
				);
				break;
			case "lockfile":
				$types=array(
					"file"=>"INTEGER:NOTRIGHT",
					"mode"=>"DATA"
				);
				$optional_types=array(
					"wouldblock"=>"BOOLEAN:NOTRIGHT"
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"file",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"file",$function,1))
					return(0);
				switch($values["mode"])
				{
					case "shared":
						$mode="1";
						break;
					case "exclusive":
						$mode="2";
						break;
					case "unlock":
						$mode="3";
						break;
					case "sharednonblocking":
						$mode="5";
						break;
					case "exclusivenonblocking":
						$mode="6";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"it was not specified a valid lockfile mode");
						return(0);
				}
				if(IsSet($values["wouldblock"]))
					$mode|=4;
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"@flock(".$values["file"].",".$mode.(IsSet($values["wouldblock"]) ? ",".$values["wouldblock"] : "").")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "isfile":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid file path value")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$path,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"file_exists($path)",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "temporaryfilename":
				$types=array(
					"filename"=>"STRING:NOTRIGHT",
					"directory"=>"STRING",
					"prefix"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"file",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"strcmp(".$values["filename"]."=tempnam(".$values["directory"].",".$values["prefix"]."),'')",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "deletefile":
				$types=array(
					"path"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"file",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"unlink(".$values["path"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "copyfile":
				$types=array(
					"from"=>"STRING",
					"to"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"file",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"copy(".$values["from"].",".$values["to"].")",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported file object function");
				return(0);
		}
		return(1);
	}

};
 
}
?>