<?php
if(!defined("METAL_FORM_INCLUDED"))
{
	define("METAL_FORM_INCLUDED",1);

/*
 * metal_form.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_form.php,v 1.69 2004/05/12 04:00:12 mlemos Exp $
 *
 */

class metal_form_class extends metal_base_class
{
	var $variables=array();
	var $dependencies=array();
	var $current_object="";
	var $class_file;
	var $class_base_path;
	var $property_defaults=array();
	var $properties=array(
		"method"=>array(array(
			"Data"=>array(
				"Value"=>"'POST'",
				"Type"=>"STRING",
				"Side"=>"RIGHT"
			),
			"Type"=>"EXPRESSION"
		)),
		"action"=>array(array(
			"Data"=>array(
				"Value"=>"\$GLOBALS['PHP_SELF']",
				"Type"=>"STRING",
				"Side"=>"RIGHT"
			),
			"Type"=>"EXPRESSION"
		))
	);
	var $input_attributes=array(
		"name"=>array(
			"Type"=>"STRING",
			"Attribute"=>"NAME"
		),
		"id"=>array(
			"Type"=>"STRING",
			"Attribute"=>"ID"
		),
		"type"=>array(
			"Type"=>"STRING",
			"Attribute"=>"TYPE"
		),
		"value"=>array(
			"Type"=>"STRING",
			"Attribute"=>"VALUE"
		),
		"onclick"=>array(
			"Type"=>"STRING",
			"Attribute"=>"ONCLICK"
		),
		"onchange"=>array(
			"Type"=>"STRING",
			"Attribute"=>"ONCHANGE"
		),
		"checked"=>array(
			"Type"=>"BOOLEAN",
			"Attribute"=>"CHECKED"
		),
		"maxlength"=>array(
			"Type"=>"INTEGER",
			"Attribute"=>"MAXLENGTH"
		),
		"size"=>array(
			"Type"=>"INTEGER",
			"Attribute"=>"SIZE"
		),
		"options"=>array(
			"Type"=>"HASH",
			"Attribute"=>"OPTIONS"
		),
		"rows"=>array(
			"Type"=>"INTEGER",
			"Attribute"=>"ROWS"
		),
		"columns"=>array(
			"Type"=>"INTEGER",
			"Attribute"=>"COLS"
		),
		"capitalization"=>array(
			"Type"=>"STRING",
			"Attribute"=>"Capitalization"
		),
		"subform"=>array(
			"Type"=>"STRING",
			"Attribute"=>"SubForm"
		),
		"tabindex"=>array(
			"Type"=>"INTEGER",
			"Attribute"=>"TABINDEX"
		),
		"clientscript"=>array(
			"Type"=>"STRING",
			"Attribute"=>"ClientScript"
		),
		"accessible"=>array(
			"Type"=>"BOOLEAN",
			"Attribute"=>"Accessible"
		),
		"label"=>array(
			"Type"=>"STRING",
			"Attribute"=>"LABEL"
		),
		"accesskey"=>array(
			"Type"=>"STRING",
			"Attribute"=>"ACCESSKEY"
		),
		"src"=>array(
			"Type"=>"STRING",
			"Attribute"=>"SRC"
		),
		"alt"=>array(
			"Type"=>"STRING",
			"Attribute"=>"ALT"
		),
		"border"=>array(
			"Type"=>"INTEGER",
			"Attribute"=>"BORDER"
		),
		"style"=>array(
			"Type"=>"STRING",
			"Attribute"=>"STYLE"
		),
		"class"=>array(
			"Type"=>"STRING",
			"Attribute"=>"CLASS"
		),
		"validation"=>array(
			"Type"=>"LIST",
			"Attributes"=>array(
				"optionalvalue"=>array(
					"Type"=>"STRING",
					"Attribute"=>"ValidateOptionalValue"
				),
				"errormessage"=>array(
					"Type"=>"STRING",
					"Attribute"=>"ValidationErrorMessage"
				),
				"matchregularexpression"=>array(
					"Type"=>"LIST",
					"Attributes"=>array(
						"errormessage"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateRegularExpressionErrorMessage"
						),
						"expression"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateRegularExpression"
						)
					)
				),
				"asnotempty"=>array(
					"Type"=>"LIST",
					"Attribute"=>"ValidateAsNotEmpty",
					"Attributes"=>array(
						"errormessage"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateAsNotEmptyErrorMessage"
						)
					)
				),
				"asemail"=>array(
					"Type"=>"LIST",
					"Attribute"=>"ValidateAsEmail",
					"Attributes"=>array(
						"errormessage"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateAsEmailErrorMessage"
						)
					)
				),
				"asequalto"=>array(
					"Type"=>"LIST",
					"Attributes"=>array(
						"errormessage"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateAsEqualToErrorMessage"
						),
						"input"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateAsEqualTo"
						)
					)
				),
				"asdifferentfrom"=>array(
					"Type"=>"LIST",
					"Attributes"=>array(
						"errormessage"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateAsDifferentFromErrorMessage"
						),
						"input"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateAsDifferentFrom"
						)
					)
				),
				"asinteger"=>array(
					"Type"=>"LIST",
					"Attribute"=>"ValidateAsInteger",
					"Attributes"=>array(
						"errormessage"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateAsIntegerErrorMessage"
						),
						"lowerlimit"=>array(
							"Type"=>"INTEGER",
							"Attribute"=>"ValidationLowerLimit"
						),
						"upperlimit"=>array(
							"Type"=>"INTEGER",
							"Attribute"=>"ValidationUpperLimit"
						)
					)
				),
				"asfloat"=>array(
					"Type"=>"LIST",
					"Attribute"=>"ValidateAsFloat",
					"Attributes"=>array(
						"errormessage"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidateAsFloatErrorMessage"
						),
						"lowerlimit"=>array(
							"Type"=>"FLOAT",
							"Attribute"=>"ValidationLowerLimit"
						),
						"upperlimit"=>array(
							"Type"=>"FLOAT",
							"Attribute"=>"ValidationUpperLimit"
						),
						"decimalplaces"=>array(
							"Type"=>"INTEGER",
							"Attribute"=>"ValidationDecimalPlaces"
						)
					)
				),
				"withclientfunction"=>array(
					"Type"=>"LIST",
					"Attributes"=>array(
						"function"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidationClientFunction"
						),
						"errormessage"=>array(
							"Type"=>"STRING",
							"Attribute"=>"ValidationClientFunctionErrorMessage"
						)
					)
				)
			)
		),
		"encoding"=>array(
			"Type"=>"LIST",
			"Attributes"=>array(
				"function"=>array(
					"Type"=>"STRING",
					"Attribute"=>"Encoding"
				),
				"scriptfile"=>array(
					"Type"=>"STRING",
					"Attribute"=>"EncodingFunctionScriptFile"
				),
				"verification"=>array(
					"Type"=>"STRING",
					"Attribute"=>"EncodingFunctionVerification"
				),
				"field"=>array(
					"Type"=>"STRING",
					"Attribute"=>"EncodedField"
				)
			)
		)
	);
	var $inputs=array();

	Function SetupInputLevel(&$compiler,&$code,&$context,$path,&$attributes,&$input,$allow_attributes,$attributes_value)
	{
		$elements=$code->structure[$path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				$attribute=$data["Tag"];
				if($allow_attributes
				&& $attribute=="attributes")
				{
					if(strcmp($attributes_value,""))
					{
						$compiler->SetElementError($context->file,$element_path,"it was specified the ".$attribute." attribute of an already defined form input field");
						return(0);
					}
					$compiler->CopyEmptyContext($context,$evaluate_context);
					$evaluate_context->path=$element_path;
					if(!$compiler->GetValidExpression($evaluate_context,"HASH","BOTH","it was not specified a valid form input arguments expression",0)
					|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$attributes_value,$expression_type))
						return(0);
					continue;
				}
				if(!IsSet($attributes[$attribute]))
				{
					$compiler->SetElementError($context->file,$element_path,$attribute." is not a supported form field attribute");
					return(0);
				}
				if(strcmp($type=$attributes[$attribute]["Type"],"LIST"))
				{
					if(IsSet($input[$attribute]))
					{
						$compiler->SetElementError($context->file,$element_path,"it was specified the ".$attribute." attribute of an already defined form input field");
						return(0);
					}
					$compiler->CopyEmptyContext($context,$evaluate_context);
					$evaluate_context->path=$element_path;
					if(!$compiler->GetValidTypedExpression($evaluate_context,$type,"it was not specified a valid form input ".$attribute." expression"))
						return(0);
					if(IsSet($attributes[$attribute]["Attribute"]))
						$attribute=$attributes[$attribute]["Attribute"];
					$input[$attribute]=$evaluate_context->result;
				}
				else
				{
					if(!$this->SetupInputLevel($compiler,$code,$context,$element_path,$attributes[$attribute]["Attributes"],$input,0,""))
						return(0);
					if(IsSet($attributes[$attribute]["Attribute"]))
					{
						$input[$attributes[$attribute]["Attribute"]]=array(array(
							"Data"=>array(
								"Value"=>1,
								"Type"=>"BOOLEAN",
								"Side"=>"RIGHT"
							),
							"Type"=>"EXPRESSION"
						));
					}
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function SetupInput(&$compiler,&$code,&$context,&$input,$allow_attributes=0,$attributes_value="")
	{
		$input=array();
		return($this->SetupInputLevel($compiler,$code,$context,$context->path,$this->input_attributes,$input,$allow_attributes,$attributes_value));
	}

	Function ParseFormDefinition(&$compiler,&$parser,&$context)
	{
		$elements=$parser->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$parser->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "name":
					case "action":
					case "method":
					case "onsubmit":
					case "allowusedlabelkeys":
					case "reservedkeys":
					case "readonly":
					case "resubmitconfirmmessage":
						$compiler->CopyEmptyContext($context,$this->property_defaults[$data["Tag"]]);
						$this->property_defaults[$data["Tag"]]->path=$element_path;
						break;
					case "input":
						$this->inputs[]=array(
							"file"=>$context->file,
							"path"=>$element_path
						);
						break;
					case "classfile":
						$compiler->CopyEmptyContext($context,$this->class_file);
						$this->class_file->path=$element_path;
						break;
					case "classbasepath":
						$compiler->CopyEmptyContext($context,$this->class_base_path);
						$this->class_base_path->path=$element_path;
						break;
					case "definition":
						if(!$compiler->GetValidData($context->file,$element_path,$definition,"it was not specified a valid forms class definition"))
							return(0);
						$this->dependencies[]=$compiler->GetIncludePath($definition).$definition;
						if(!$compiler->ParseDefinitionFile($definition))
							return(0);
						$compiler->GetParser($definition_parser,$definition);
						if($definition_parser->structure["0"]["Tag"]!="form")
							return($compiler->SetElementError($definition,"0","it was not specified a valid form definition file"));
						$compiler->CreateFileContext($definition_context,$definition);
						if(!$this->ParseFormDefinition($compiler,$definition_parser,$definition_context))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported form object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Setup(&$compiler,&$code,&$attributes)
	{
		return($this->ParseFormDefinition($compiler,$code,$attributes));
	}

	Function OutputMethodArray(&$compiler,&$context,&$array,$method,$object)
	{
		$context->result[]=array(
			"Data"=>$object."->".$method."(array(",
			"Type"=>"COMMAND"
		);
		$context->result[]=array(
			"Data"=>1,
			"Type"=>"INDENT"
		);
		for($argument=0,Reset($array);$argument<count($array);Next($array),$argument++)
		{
			$argument_name=Key($array);
			if(!$compiler->ConvertData($context,"STRING",$argument_name,$argument_name_value)
			|| !$compiler->GetExpressionValue($context,$array[$argument_name],$argument_expression,$expression_type))
				return(0);
			$context->result[]=array(
				"Data"=>$argument_name_value."=>".$argument_expression.($argument<count($array)-1 ? "," : ""),
				"Type"=>"COMMAND"
			);
		}
		$context->result[]=array(
			"Data"=>1,
			"Type"=>"OUTDENT"
		);
		$context->result[]=array(
			"Data"=>"));",
			"Type"=>"COMMAND"
		);
		return(1);
	}

	Function OutputAttributesArray(&$compiler,&$context,&$array,$attributes_value)
	{
		for($argument=0,Reset($array);$argument<count($array);Next($array),$argument++)
		{
			$argument_name=Key($array);
			if(!$compiler->ConvertData($context,"STRING",$argument_name,$argument_name_value)
			|| !$compiler->GetExpressionValue($context,$array[$argument_name],$argument_expression,$expression_type))
				return(0);
			$context->result[]=array(
				"Data"=>$attributes_value."[".$argument_name_value."]=".$argument_expression.";",
				"Type"=>"COMMAND"
			);
		}
		return(1);
	}

	Function FlushPendingData(&$compiler,&$context,&$pending_data,&$pending_string,$object,$flush_string=1)
	{
		if(strlen($pending_data))
		{
			if(!$compiler->ConvertData($context,"STRING",$pending_data,$string))
				return(0);
			if(strlen($pending_string))
				$pending_string.=".";
			$pending_string.=$string;
			$pending_data="";
		}
		if($flush_string
		&& strlen($pending_string))
		{
			$context->result[]=array(
				"Data"=>$object."->AddDataPart($pending_string);",
				"Type"=>"COMMAND"
			);
			$pending_string="";
		}
		return(1);
	}

	Function GetObject(&$compiler,&$context,$element_path,&$object)
	{
		if(strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$element_path,"it was specified the form object argument");
			return(0);
		}
		$compiler->CopyEmptyContext($context,$evaluate_context);
		$evaluate_context->path=$element_path;
		if(!$compiler->GetValidExpression($evaluate_context,"OBJECT","NOTRIGHT","it was not specified a valid form object expression",1)
		|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$object,$expression_type))
			return(0);
		return(1);
	}

	Function GetFormArguments(&$compiler,&$code,&$context,&$object)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "object":
						if(!$this->GetObject($compiler,$context,$element_path,$object))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported form argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function VerifyFormArguments(&$compiler,&$code,&$context,&$object)
	{
		$object="";
		if(!$this->GetFormArguments($compiler,$code,$context,$object))
			return(0);
		If(strlen($object)==0)
		{
			if(strlen($this->current_object)==0)
				return($compiler->SetElementError($context->file,$context->path,"it was not specified the form object argument"));
			$object=$this->current_object;
		}
		return(1);
	}

	Function GetProperty(&$compiler,&$context,$property,&$value,$optional)
	{
		switch($property)
		{
			case "name":
			case "action":
			case "method":
			case "onsubmit":
			case "resubmitconfirmmessage":
				$type="STRING";
				break;
			case "reservedkeys":
				$type="HASH";
				break;
			case "allowusedlabelkeys":
			case "readonly":
				$type="BOOLEAN";
				break;
			default:
				return($compiler->SetElementError($context->file,$context->path,$property." is not was a supported form property"));
		}
		if(IsSet($this->property_defaults[$property]))
		{
			$compiler->CopyEmptyContext($this->property_defaults[$property],$evaluate_context);
			if(!$compiler->GetValidTypedExpression($evaluate_context,$type,"it was not specified a valid form ".$property." expression"))
				return(0);
			$this->properties[$property]=$evaluate_context->result;
		}
		else
		{
			if(!IsSet($this->properties[$property]))
				return($optional ? 1 : $compiler->SetElementError($context->file,$context->path,"it was not specified the form property ".$property));
		}
		return($compiler->GetExpressionValue($context,$this->properties[$property],$value,$expression_type));
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the form class");
			return(0);
		}
		switch($function)
		{
			case "new":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object)
				|| !$this->GetProperty($compiler,$context,"name",$name,1)
				|| !$this->GetProperty($compiler,$context,"method",$method,0)
				|| !$this->GetProperty($compiler,$context,"action",$action,0)
				|| !$this->GetProperty($compiler,$context,"onsubmit",$onsubmit,1)
				|| !$this->GetProperty($compiler,$context,"allowusedlabelkeys",$allow_used_label_keys,1)
				|| !$this->GetProperty($compiler,$context,"reservedkeys",$reserved_keys,1)
				|| !$this->GetProperty($compiler,$context,"readonly",$read_only,1)
				|| !$this->GetProperty($compiler,$context,"resubmitconfirmmessage",$resubmit_confirm_message,1))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>$object."=new form_class;",
					"Type"=>"COMMAND"
				);
				if(IsSet($this->properties["name"]))
				{
					$context->result[]=array(
						"Data"=>$object."->NAME=$name;",
						"Type"=>"COMMAND"
					);
				}
				$context->result[]=array(
					"Data"=>$object."->METHOD=$method;",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>$object."->ACTION=$action;",
					"Type"=>"COMMAND"
				);
				if(IsSet($this->properties["onsubmit"]))
				{
					$context->result[]=array(
						"Data"=>$object."->ONSUBMIT=$onsubmit;",
						"Type"=>"COMMAND"
					);
				}
				if(IsSet($this->properties["allowusedlabelkeys"]))
				{
					$context->result[]=array(
						"Data"=>$object."->allow_used_label_keys=$allow_used_label_keys;",
						"Type"=>"COMMAND"
					);
				}
				if(IsSet($this->properties["reservedkeys"]))
				{
					$context->result[]=array(
						"Data"=>$object."->reserved_access_keys=$reserved_access_keys;",
						"Type"=>"COMMAND"
					);
				}
				if(IsSet($this->properties["readonly"]))
				{
					$context->result[]=array(
						"Data"=>$object."->ReadOnly=$read_only;",
						"Type"=>"COMMAND"
					);
				}
				if(IsSet($this->properties["resubmitconfirmmessage"]))
				{
					$context->result[]=array(
						"Data"=>$object."->ResubmitConfirmMessage=$resubmit_confirm_message;",
						"Type"=>"COMMAND"
					);
				}
				for($input=0;$input<count($this->inputs);$input++)
				{
					$this->inputs[$input]["definition"]=array();
					$compiler->CopyEmptyContext($context,$input_context);
					$input_context->file=$this->inputs[$input]["file"];
					$input_context->path=$this->inputs[$input]["path"];
					$compiler->GetParser($input_parser,$input_context->file);
					if(!$this->SetupInput($compiler,$input_parser,$input_context,$this->inputs[$input]["definition"])
					|| !$this->OutputMethodArray($compiler,$context,$this->inputs[$input]["definition"],"AddInput",$object))
						return(0);
				}
				break;
			case "compose":
				Unset($object);
				$skip_white_space=0;
				$elements=$arguments_code->structure[$arguments->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$arguments->path.",$element";
					$data=$arguments_code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "object":
								if(!$this->GetObject($compiler,$arguments,$element_path,$object))
									return(0);
								break;
							case "skipwhitespace":
								if(!$compiler->GetValidData($arguments->file,$element_path,$skip_white_space,"it was not specified a valid form compose skipwhitespace option"))
									return(0);
								if(strcmp($skip_white_space,"1")
								&& strcmp($skip_white_space,"0"))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was not specified a valid boolean form compose skipwhitespace option value");
									return(0);
								}
								$skip_white_space=intval($skip_white_space);
								break;
							default:
								$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a supported form object compose argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
							return(0);
					}
				}
				If(!IsSet($object))
				{
					if(strlen($this->current_object)==0)
						return($compiler->SetElementError($context->file,$context->path,"it was not specified the form object argument"));
					$object=$this->current_object;
				}
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$elements=$code->structure[$context->path]["Elements"];
				for($pending_data=$pending_string="",$element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "input":
							case "hiddeninput":
								if(!$this->FlushPendingData($compiler,$context,$pending_data,$pending_string,$object))
									return(0);
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid form ".$data["Tag"]." name expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$name,$expression_type))
									return(0);
								$add_input_functions=array(
									"input"=>"AddInputPart",
									"hiddeninput"=>"AddInputHiddenPart"
								);
								$context->result[]=array(
									"Data"=>$object."->".$add_input_functions[$data["Tag"]]."($name);",
									"Type"=>"COMMAND"
								);
								break;
							case "hiddeninputs":
								if(!$this->FlushPendingData($compiler,$context,$pending_data,$pending_string,$object))
									return(0);
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"HASH","it was not specified a valid form hiddeninputs associative array expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$inputs,$expression_type))
									return(0);
								$context->result[]=array(
									"Data"=>$object."->AddHiddenInputsParts($inputs);",
									"Type"=>"COMMAND"
								);
								break;
							case "label":
								if(!$this->FlushPendingData($compiler,$context,$pending_data,$pending_string,$object))
									return(0);
								$label=array();
								$label_elements=$code->structure[$element_path]["Elements"];
								for($label_element=0;$label_element<$label_elements;$label_element++)
								{
									$label_element_path=$element_path.",$label_element";
									$data=$code->structure[$label_element_path];
									if(GetType($data)=="array")
									{
										switch($data["Tag"])
										{
											case "for":
											case "accesskey":
											case "label":
												if(IsSet($label[$data["Tag"]]))
												{
													$compiler->SetElementError($context->file,$label_element_path,"it was specified the ".$data["Tag"]." attribute of an already defined form label");
													return(0);
												}
												$compiler->CopyEmptyContext($context,$evaluate_context);
												$evaluate_context->path=$label_element_path;
												if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid form label ".$data["Tag"]." expression"))
													return(0);
												$label[strtoupper($data["Tag"])]=$evaluate_context->result;
												break;
											default:
												$compiler->SetElementError($context->file,$label_element_path,$data["Tag"]." is not a supported form label attribute");
												return(0);
										}
									}
									else
									{
										if(!$compiler->CheckWhiteSpace($context->file,$data,$label_element_path))
											return(0);
									}
								}
								if(!$this->OutputMethodArray($compiler,$context,$label,"AddLabelPart",$object))
									return(0);
								break;
							case "data":
								$compose_data=array();
								if(!$compiler->GetOutputData($context->file,$element_path,$compose_data,"it was not specified valid form compose data",1))
									return(0);
								for($part=0;$part<count($compose_data);$part++)
								{
									switch($compose_data[$part]["Type"])
									{
										case "DATA":
											if(strlen($compose_data[$part]["Data"]))
												$pending_data.=$compose_data[$part]["Data"];
											break;
										case "EXPRESSION":
											if(!$this->FlushPendingData($compiler,$context,$pending_data,$pending_string,$object,0))
												return(0);
											$expression=array($compose_data[$part]);
											if(!$compiler->GetExpressionValue($context,$expression,$expression_value,$expression_type))
												return(0);
											if(strlen($pending_string))
												$pending_string.=".";
											$pending_string.=$expression_value;
											break;
										default:
											if(!$this->FlushPendingData($compiler,$context,$pending_data,$pending_string,$object))
												return(0);
											$context->result[]=$compose_data[$part];
											break;
									}
								}
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported form object compose argument");
								return(0);
						}
					}
					else
					{
						if(strlen($data))
						{
							if($skip_white_space)
							{
								if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
									return(0);
							}
							else
								$pending_data.=$data;
						}
					}
				}
				if(!$this->FlushPendingData($compiler,$context,$pending_data,$pending_string,$object))
					return(0);
				break;
			case "output":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"FormCaptureOutput($object,array('EndOfLine'=>\"\\n\"))",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "loadinputvalues":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object))
					return(0);
				Unset($submitted);
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "submitted":
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"BOOLEAN","it was not specified a valid form loadinputvalues submitted expression"))
									return(0);
								$submitted=$evaluate_context->result;
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported form object loadinputvalues parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				if(IsSet($submitted))
				{
					if(!$compiler->GetExpressionValue($context,$submitted,$submitted_expression,$expression_type))
						return(0);
				}
				else
					$submitted_expression="";
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$object."->LoadInputValues($submitted_expression)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "addinput":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object)
				|| !$this->SetupInput($compiler,$code,$context,$input,1,$attributes_value))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				if(strcmp($attributes_value,""))
				{
				  if(!$this->OutputAttributesArray($compiler,$context,$input,$attributes_value))
				  	return(0);
					$context->result[]=array(
						"Data"=>$object."->AddInput($attributes_value);",
						"Type"=>"COMMAND"
					);
				}
				else
				{
					if(!$this->OutputMethodArray($compiler,$context,$input,"AddInput",$object))
						return(0);
				}
				break;
			case "addfunction":
				$types=array(
					"object"=>"OBJECT:NOTLEFT",
					"name"=>"STRING",
					"type"=>"STRING",
					"input"=>"STRING"
				);
				if(!$compiler->GetArgumentValues($arguments_code,$arguments,$code,$context,$values,$types,"form",$function))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>$values["object"]."->AddFunction(array(",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				$context->result[]=array(
					"Data"=>"'Function'=>".$values["name"].",",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>"'Type'=>".$values["type"].",",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>"'Element'=>".$values["input"],
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$context->result[]=array(
					"Data"=>"));",
					"Type"=>"COMMAND"
				);
				break;
			case "setinputattributes":
				if(!$this->SetupInput($compiler,$code,$context,$input,1,$attributes_value))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				if(!strcmp($attributes_value,""))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the form attributes array expression");
					return(0);
				}
				if(count($input)==0)
				{
					$compiler->SetElementError($context->file,$context->path,"it were not specified any form attributes");
					return(0);
				}
				if(!$this->OutputAttributesArray($compiler,$context,$input,$attributes_value))
					return(0);
				break;
			case "addhiddeninputs":
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object)
				|| !$compiler->GetValidExpression($evaluate_context,"HASH","NOTLEFT","it was not specified a valid form hiddeninputs associative array",1)
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$inputs,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$object."->AddHiddenInputs($inputs)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "validate":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object))
					return(0);
				Unset($verify_expression);
				Unset($subform_expression);
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "verifyfields":
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"HASH:NOTRIGHT","it was not specified a valid form validate verify expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$verify_expression,$expression_type))
									return(0);
								break;
							case "subform":
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid form validate subform expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$subform_expression,$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported form object validate parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($verify_expression))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not a specified the form object validate verify argument");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$object."->Validate($verify_expression".(IsSet($subform_expression) ? ",$subform_expression" : "").")",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "setinputvalue":
			case "getinputvalue":
			case "getinputcheckedstate":
			case "setinputcheckedstate":
			case "setinputproperty":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object))
					return(0);
				$type="STRING";
				$input_value=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "input":
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid form $function input expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$input_value["input"],$expression_type))
									return(0);
								break;
							case "value":
								switch($function)
								{
									case "setinputproperty":
										if(!IsSet($input_value["property"]))
										{
											$compiler->SetElementError($context->file,$element_path,"it was specified the property value before specifing the property name");
											return(0);
										}
									case "setinputcheckedstate":
									case "setinputvalue":
										break;
									default:
										$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported form object $function parameter");
										return(0);
								}
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression($evaluate_context,$type,"it was not specified a valid form $function value expression")
								|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$input_value["value"],$expression_type))
									return(0);
								break;
							case "property":
								if(!strcmp($function,"setinputproperty"))
								{
									if(!IsSet($input_value["input"]))
									{
										$compiler->SetElementError($context->file,$element_path,"it was not specified the input before specifing the property name");
										return(0);
									}
									if(!$compiler->GetValidData($context->file,$element_path,$property,"it was not specified a valid input property name"))
										return(0);
									if(!IsSet($this->input_attributes[$property]))
									{
										$compiler->SetElementError($context->file,$element_path,$property." is not a supported settable input property");
										return(0);
									}
									switch($this->input_attributes[$property]["Type"])
									{
										case "BOOLEAN":
										case "INTEGER":
										case "STRING":
											$type=$this->input_attributes[$property]["Type"];
											break;
										default:
											$compiler->SetElementError($context->file,$element_path,$property." is not a supported settable input property");
											return(0);
									}
									if(!$compiler->ConvertData($context,"STRING",$this->input_attributes[$property]["Attribute"],$property_string))
										return(0);
									$input_value["property"]=$property_string;
									break;
								}
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported form object $function parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($input_value[$argument="input"])
				|| (!strcmp($function,"setinputproperty")
				&& !IsSet($input_value[$argument="property"]))
				|| (strcmp($function,"getinputvalue")
				&& strcmp($function,"getinputcheckedstate")
				&& !IsSet($input_value[$argument="value"])))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not a specified the form object $function argument");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$type="STRING";
				switch($function)
				{
					case "setinputproperty":
						$expression=$object."->SetInputProperty(".$input_value["input"].",".$input_value["property"].",".$input_value["value"].")";
						break;
					case "setinputvalue":
						$expression=$object."->SetInputValue(".$input_value["input"].",".$input_value["value"].")";
						break;
					case "getinputvalue":
						$expression=$object."->GetInputValue(".$input_value["input"].")";
						break;
					case "setinputcheckedstate":
						$expression=$object."->SetCheckedState(".$input_value["input"].",".$input_value["value"].")";
						break;
					case "getinputcheckedstate":
						$type="BOOLEAN";
						$expression=$object."->GetCheckedState(".$input_value["input"].")";
						break;
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$expression,
						"Type"=>$type,
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "name":
			case "method":
			case "action":
			case "onsubmit":
			case "allowusedlabelkeys":
			case "reservedkeys":
			case "readonly":
			case "resubmitconfirmmessage":
			case "changes":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$type="STRING";
				$side="BOTH";
				$value=strtoupper($function);
				switch($function)
				{
					case "allowusedlabelkeys":
						$type="BOOLEAN";
						$value="allow_used_label_keys";
						break;
					case "reservedkeys":
						$type="HASH";
						$value="reserved_access_keys";
						break;
					case "readonly":
						$type="BOOLEAN";
						$value="ReadOnly";
						break;
					case "resubmitconfirmmessage":
						$value="ResubmitConfirmMessage";
						break;
					case "changes":
						$type="HASH";
						$side="RIGHT";
						$value="Changes";
						break;
				}
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$object."->".$value,
						"Type"=>$type,
						"Side"=>$side
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "definedinputvalue":
			case "inputvalue":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$compiler->CopyEmptyContext($context,$evaluate_context);
				if(!$compiler->GetValidTypedExpression($evaluate_context,"STRING","it was not specified a valid form input name expression")
				|| !$compiler->GetExpressionValue($context,$evaluate_context->result,$name,$expression_type))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>($function=="definedinputvalue" ? "!!strcmp(".$object."->WasSubmitted($name),'')" : $object."->GetGlobal($name)"),
						"Type"=>$function=="definedinputvalue" ? "BOOLEAN" : "STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "wassubmitted":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object))
					return(0);
				$values=array();
				$required_types=array();
				$optional_types=array(
					"object"=>"OBJECT:NOTRIGHT",
					"input"=>"STRING"
				);
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$required_types,$optional_types,"form",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$required_types,$optional_types,"form",$function,1))
					return(0);
				$input=(IsSet($values["input"]) ? $values["input"] : "''");
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"strlen(".$object."->WasSubmitted($input))!=0",
						"Type"=>"BOOLEAN",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "resetparts":
				if(!$this->VerifyFormArguments($compiler,$arguments_code,$arguments,$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>$object."->ResetFormParts();",
					"Type"=>"COMMAND"
				);
				break;
			case "forform":
				$values=array();
				$required_types=array(
					"object"=>"OBJECT:NOTRIGHT",
					"do"=>"CONTEXT",
				);
				$optional_types=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$required_types,$optional_types,"form",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$required_types,$optional_types,"form",$function,1))
					return(0);
				$functions=array(
					"action",
					"addinput",
					"addfunction",
					"allowusedlabelkeys",
					"changes",
					"compose",
					"definedinputvalue",
					"getinputvalue",
					"getinputcheckedstate",
					"inputvalue",
					"loadinputvalues",
					"method",
					"name",
					"new",
					"onsubmit",
					"output",
					"readonly",
					"reservedkeys",
					"resetparts",
					"resubmitconfirmmessage",
					"setinputattributes",
					"setinputcheckedstate",
					"setinputproperty",
					"setinputvalue",
					"setvariable",
					"validate",
					"variable",
					"wassubmitted"
				);
				if(!$compiler->AddContextFunctions($context,$this->object_name,$functions,$level))
					return(0);
				$current_object=$this->current_object;
				$this->current_object=$values["object"];
				$success=$compiler->GetOutputData($values["do"]->file,$values["do"]->path,$context->result,"it was not defined valid action for the for form",1);
				$this->current_object=$current_object;
				if(!$success
				|| !$compiler->RemoveContextFunctions($context,$this->object_name,$level))
					return(0);
				break;
			case "variable":
				if(!$compiler->GetValidName($context->file,$context->path,$variable,"it was not specified a valid form variable name"))
					return(0);
				if(!IsSet($this->variables[$variable]))
					return($compiler->SetElementError($context->file,$context->path,"it was specified a form variable ($variable) that was not defined"));
				if(!$compiler->GetOutputData($this->variables[$variable]->file,$this->variables[$variable]->path,$context->result,"it was not specified valid form variable value",0))
					return(0);
				break;
			case "setvariable":
				$values=array();
				$required_types=array();
				$optional_types=array(
					"name"=>"NAME",
					"value"=>"CONTEXT"
				);
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$required_types,$optional_types,"form",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$required_types,$optional_types,"form",$function,1))
					return(0);
				$compiler->CopyEmptyContext($values["value"],$this->variables[$values["name"]]);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported form object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the form class");
			return(0);
		}
		if(IsSet($this->class_file))
		{
			$compiler->CopyEmptyContext($this->class_file,$class_file_context);
			if(!$compiler->GetValidData($this->class_file->file,$this->class_file->path,$class_file,"it was not specified a valid forms class file"))
				return(0);
		}
		else
		{
			$compiler->CopyEmptyContext($context,$class_file_context);
			$class_file="forms.php";
		}
		if(!file_exists($class_file))
		{
			$compiler->SetElementError($this->class_file->file,$this->class_file->path,"it was not specified a valid an existing forms class file (\"$class_file\")");
			return(0);
		}
		if(IsSet($this->class_base_path))
		{
			if(!$compiler->GetValidData($this->class_base_path->file,$this->class_base_path->path,$class_base_path,"it was not specified a valid forms class base path"))
				return(0);
		}
		else
			$class_base_path="";
		$relative_path=$compiler->RelativePath($class_base_path,$class_file);
		if(!$compiler->ConvertData($context,"STRING",$relative_path,$relative_path_value))
			return(0);
		$context->result[]=array(
			"Data"=>array(
				"Name"=>$class_file,
				"Type"=>"SUPPLIED"
			),
			"Type"=>"FILE"
		);
		$context->result[]=array(
			"Data"=>"require(".$relative_path_value.");",
			"Type"=>"COMMAND"
		);
		for($dependency=0;$dependency<count($this->dependencies);$dependency++)
		{
			$context->result[]=array(
				"Data"=>array(
					"Name"=>$this->dependencies[$dependency],
					"Type"=>"DEPENDENCY"
				),
				"Type"=>"FILE"
			);
		}
		return(1);
	}

};
 
}
?>