<?php
if(!defined("HTML_INCLUDED"))
{
	define("HTML_INCLUDED",1);

/*
 * html.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_html.php,v 1.25 2004/09/14 20:04:46 mlemos Exp $
 *
 */
 
class html_class extends metal_base_class
{
	var $properties=array();
	var $tables_of_contents=array();
	var $header="";
	var $footer="";

	Function AddResultDataPart(&$output,$data)
	{
		if(($last=count($output)-1)>=0
		&& $output[$last]["Type"]=="DATA")
			$output[$last]["Data"].=$data;
		else
		{
			$output[]=array(
				"Data"=>$data,
				"Type"=>"DATA"
			);
		}
	}

	Function GetParagraphStyleAttributes(&$compiler, &$context, &$paragraph, &$attributes)
	{
		if(IsSet($paragraph["Data"]["Style"]))
		{
			$style="";
			if(IsSet($paragraph["Data"]["Style"]["backgroundcolor"]))
				$style.="background-color: ".$paragraph["Data"]["Style"]["backgroundcolor"]."; ";
			if(IsSet($paragraph["Data"]["Style"]["align"]))
			{
				switch($paragraph["Data"]["Style"]["align"])
				{
					case "left":
					case "right":
					case "center":
					case "justify":
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,$paragraph["Data"]["Style"]["align"]." is not a supported paragraph style align mode");
						return(0);
				}
				$style.="text-align: ".$paragraph["Data"]["Style"]["align"]."; ";
			}
			if(strlen($style))
			{
				$attributes.=" style=\"".HtmlEntities($style)."\"";
			}
		}
		return(1);
	}

	Function OutputResult(&$compiler,&$context,&$result,&$output,$start,$end)
	{
		for($part=$start;$part<$end;$part++)
		{
			switch($result[$part]["Type"])
			{
				case "EXPRESSION":
					switch($result[$part]["Data"]["Type"])
					{
						case "DOCUMENT.START":
							if($this->document_start)
							{
								$compiler->SetElementError($context->file,$context->path,"the document start was specified more than once");
								return(0);
							}
							$this->document_start=1;
							break;
						case "DOCUMENT.END":
							if(!$this->document_start)
							{
								$compiler->SetElementError($context->file,$context->path,"the document start was not specified before the document end");
								return(0);
							}
							if($this->document_end)
							{
								$compiler->SetElementError($context->file,$context->path,"the document end was specified more than once");
								return(0);
							}
							$this->document_end=1;
							break;
						case "BODY.START":
							if(!$this->document_start)
							{
								$compiler->SetElementError($context->file,$context->path,"the document body was specified before specifying the document start");
								return(0);
							}
							if($this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"the document body start was specified more than once");
								return(0);
							}
							$this->AddResultDataPart($output,$this->header);
							$this->encode=$this->body_start=1;
							break;
						case "BODY.END":
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"the document body start was not specified before the document body end");
								return(0);
							}
							if($this->body_end)
							{
								$compiler->SetElementError($context->file,$context->path,"the document body end was specified more than once");
								return(0);
							}
							$this->AddResultDataPart($output,$this->footer);
							$this->body_end=1;
							$this->encode=0;
							break;
						case "PARAGRAPH.START":
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"a paragraph was specified before specifying the document body start");
								return(0);
							}
							if($this->paragraph!="")
							{
								$compiler->SetElementError($context->file,$context->path,"a paragraph was specified inside another paragraph");
								return(0);
							}
							$this->paragraph="p";
							if(IsSet($result[$part]["Data"]["Style"]["paragraph"]))
							{
								switch($result[$part]["Data"]["Style"]["paragraph"])
								{
									case "HEADING":
										if($result[$part]["Data"]["Level"]<=6)
											$this->paragraph="h".$result[$part]["Data"]["Level"];
										break;
								}
							}
							$attributes="";
							if(!$this->GetParagraphStyleAttributes($compiler, $context, $result[$part], $attributes))
								return(0);
							$this->AddResultDataPart($output,"<".$this->paragraph.$attributes.">");
							break;
						case "PARAGRAPH.END":
							if($this->paragraph=="")
							{
								$compiler->SetElementError($context->file,$context->path,"a paragraph start was not specified before the paragraph end");
								return(0);
							}
							$this->AddResultDataPart($output,"</$this->paragraph>\n");
							$this->paragraph="";
							break;
						case "PREFORMATTED.START":
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"a preformatted section was specified before specifying the document body start");
								return(0);
							}
							if($this->paragraph=="pre")
							{
								$compiler->SetElementError($context->file,$context->path,"a preformatted section was specified inside another preformatted section");
								return(0);
							}
							$attributes="";
							if(!$this->GetParagraphStyleAttributes($compiler, $context, $result[$part], $attributes))
								return(0);
							$this->paragraph="pre";
							$this->AddResultDataPart($output,"<pre".$attributes.">");
							break;
						case "PREFORMATTED.END":
							if($this->paragraph!="pre")
							{
								$compiler->SetElementError($context->file,$context->path,"a preformattted start was not specified before the preformatted end");
								return(0);
							}
							$this->AddResultDataPart($output,"</pre>\n");
							$this->paragraph="";
							break;
						case "LIST.START":
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"a list was specified before specifying the document body start");
								return(0);
							}
							$this->AddResultDataPart($output,"<ul>\n");
							$this->lists++;
							break;
						case "LIST.END":
							if($this->lists==0)
							{
								$compiler->SetElementError($context->file,$context->path,"a list end was specified without the respective list start");
								return(0);
							}
							$this->AddResultDataPart($output,"</ul>\n");
							$this->lists--;
							break;
						case "LISTITEM.START":
							if($this->lists==0)
							{
								$compiler->SetElementError($context->file,$context->path,"a list item was specified before specifying a list");
								return(0);
							}
							if($this->list_item)
							{
								$compiler->SetElementError($context->file,$context->path,"it was specified a list item start inside another list item");
								return(0);
							}
							$this->AddResultDataPart($output,"<li>");
							$this->list_item=1;
							break;
						case "LISTITEM.END":
							if(!$this->list_item)
							{
								$compiler->SetElementError($context->file,$context->path,"it was specified a list item end before a list item start");
								return(0);
							}
							$this->AddResultDataPart($output,"</li>");
							$this->list_item=0;
							break;
						case "SECTIONBREAK":
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"a section break was specified before specifying the document body start");
								return(0);
							}
							$this->AddResultDataPart($output,"<hr />\n");
							break;
						case "PARAGRAPHBREAK":
							if(!strcmp($this->paragraph,""))
							{
								$compiler->SetElementError($context->file,$context->path,"a paragraph break was specified before specifying a paragraph start");
								return(0);
							}
							$this->AddResultDataPart($output,"</".$this->paragraph.">\n<".$this->paragraph.">");
							break;
						case "LINEBREAK":
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"a line break was specified before specifying the document body start");
								return(0);
							}
							$this->AddResultDataPart($output,"<br />\n");
							break;
						case "MONOSPACED.START":
						case "BOLD.START":
						case "ITALIC.START":
							if($this->paragraph==""
							&& $this->list_item==0)
							{
								$compiler->SetElementError($context->file,$context->path,"it was specified MONOSPACED text style outside a paragraph");
								return(0);
							}
							switch($result[$part]["Data"]["Type"])
							{
								case "MONOSPACED.START":
									$tag="tt";
									$this->monospaced=1;
									break;
								case "BOLD.START":
									$tag="b";
									$this->bold=1;
									break;
								case "ITALIC.START":
									$tag="i";
									$this->italic=1;
									break;
							}
							$this->AddResultDataPart($output,"<$tag>");
							break;
						case "MONOSPACED.END":
						case "BOLD.END":
						case "ITALIC.END":
							switch($result[$part]["Data"]["Type"])
							{
								case "MONOSPACED.END":
									$tag="tt";
									if(!$this->monospaced)
									{
										$compiler->SetElementError($context->file,$context->path,"it was specified monospaced style end before a monospaced style start");
										return(0);
									}
									$this->monospaced=0;
									break;
								case "BOLD.END":
									$tag="b";
									if(!$this->bold)
									{
										$compiler->SetElementError($context->file,$context->path,"it was specified monospaced style end before a bold style start");
										return(0);
									}
									$this->bold=0;
									break;
								case "ITALIC.END":
									$tag="i";
									if(!$this->italic)
									{
										$compiler->SetElementError($context->file,$context->path,"it was specified italic style end before a italic style start");
										return(0);
									}
									$this->italic=0;
									break;
							}
							$this->AddResultDataPart($output,"</$tag>");
							break;
						case "TABLEOFCONTENTS.START":
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"a table of contents was specified before specifying the document body start");
								return(0);
							}
							for($start_contents=$end_contents=$part+1;$end_contents<$end;$end_contents++)
							{
								switch($result[$end_contents]["Type"])
								{
									case "EXPRESSION":
										switch($result[$end_contents]["Data"]["Type"])
										{
											case "TABLEOFCONTENTS.START":
												$compiler->SetElementError($context->file,$context->path,"it was specified a table of contents inside another table of contents");
												return(0);
											case "TABLEOFCONTENTS.END":
												break 3;
										}
								}
							}
							if($end_contents>=$end)
							{
								$compiler->SetElementError($context->file,$context->path,"it was not specified the end of a table of contents");
								return(0);
							}
							$document_context=$result[$part]["Data"]["Context"];
							$this->tables_of_contents[$document_context]=array();
							if(!$this->OutputResult($compiler,$context,$result,$output,$start_contents,$end_contents))
								return(0);
							$after_table_output=array();
							if(!$this->OutputResult($compiler,$context,$result,$after_table_output,$end_contents+1,$end))
								return(0);
							for($level=0,$entry=0;$entry<count($this->tables_of_contents[$document_context]);$entry++)
							{
								$new_level=$this->tables_of_contents[$document_context][$entry]["Level"];
								if($new_level>$level)
								{
									for(;$level<$new_level;$level++)
										$this->AddResultDataPart($output,"<ul>\n");
								}
								else
								{
									if($new_level<$level)
									{
										for(;$level>$new_level;$level--)
											$this->AddResultDataPart($output,"</ul>\n");
									}
								}
								$this->AddResultDataPart($output,"<li>");
								for($part=0;$part<count($this->tables_of_contents[$document_context][$entry]["Definition"]);$part++)
									$output[]=$this->tables_of_contents[$document_context][$entry]["Definition"][$part];
								$this->AddResultDataPart($output,"</li>\n");
							}
							for(;$level>0;$level--)
								$this->AddResultDataPart($output,"</ul>\n");
							for($part=0;$part<count($after_table_output);$part++)
								$output[]=$after_table_output[$part];
							return(1);
						case "TABLEOFCONTENTS.END":
							$compiler->SetElementError($context->file,$context->path,"it was specified a table of contents end before the table of contents start");
							return(0);
						case "TABLEOFCONTENTS.ENTRY.START":
							for($start_entry=$end_entry=$part+1;$end_entry<$end;$end_entry++)
							{
								switch($result[$end_entry]["Type"])
								{
									case "EXPRESSION":
										switch($result[$end_entry]["Data"]["Type"])
										{
											case "TABLEOFCONTENTS.ENTRY.START":
												$compiler->SetElementError($context->file,$context->path,"it was specified a table of contents entry inside another table of contents entry");
												return(0);
											case "TABLEOFCONTENTS.ENTRY.END":
												break 3;
										}
								}
							}
							if($end_entry>=$end)
							{
								$compiler->SetElementError($context->file,$context->path,"it was not specified the end of a table of contents entry");
								return(0);
							}
							$document_context=$result[$part]["Data"]["Context"];
							$entry=count($this->tables_of_contents[$document_context]);
							$this->tables_of_contents[$document_context][$entry]=array(
								"Level"=>$result[$part]["Data"]["Level"],
								"Name"=>$result[$part]["Data"]["Name"]
							);
							$this->tables_of_contents[$document_context][$entry]["Definition"]=array();
							if(!$this->OutputResult($compiler,$context,$result,$this->tables_of_contents[$document_context][$entry]["Definition"],$start_entry,$end_entry))
								return(0);
							$part=$end_entry;
							break;
						case "TABLEOFCONTENTS.ENTRY.END":
							$compiler->SetElementError($context->file,$context->path,"it was specified a table of contents entry end before the table of contents entry start");
							return(0);
						case "LINK.START":
							if($this->link)
							{
								$compiler->SetElementError($context->file,$context->path,"a link start was specified before specifying the last link end");
								return(0);
							}
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"a link was specified before specifying the document body start");
								return(0);
							}
							$url=$name="";
							if(IsSet($result[$part]["Data"]["URL"]))
								$url=$result[$part]["Data"]["URL"];
							if(IsSet($result[$part]["Data"]["Name"]))
								$url.="#".$result[$part]["Data"]["Name"];
							if(IsSet($result[$part]["Data"]["Anchor"]))
								$name=$result[$part]["Data"]["Anchor"];
							if(!strcmp($url,"")
							&& !strcmp($name,""))
							{
								$compiler->SetElementError($context->file,$context->path,"it was not specified the link URL or anchor Name");
								return(0);
							}
							$this->AddResultDataPart($output,"<a".(strcmp($name,"") ? " name=\"$name\"" : "").(strcmp($url,"") ? " href=\"$url\"" : "").">");
							$this->link=1;
							break;
						case "LINK.END":
							if(!$this->link)
							{
								$compiler->SetElementError($context->file,$context->path,"a link end was specified before specifying a link end");
								return(0);
							}
							$this->AddResultDataPart($output,"</a>");
							$this->link=0;
							break;
						case "MARK.START":
							if($this->mark)
							{
								$compiler->SetElementError($context->file,$context->path,"a mark start was specified before specifying the last mark end");
								return(0);
							}
							if(!$this->body_start)
							{
								$compiler->SetElementError($context->file,$context->path,"a mark was specified before specifying the document body start");
								return(0);
							}
							$this->AddResultDataPart($output,"<a name=\"".HtmlEntities($result[$part]["Data"]["Name"])."\">");
							$this->mark=1;
							break;
						case "MARK.END":
							if(!$this->mark)
							{
								$compiler->SetElementError($context->file,$context->path,"a mark end was specified before specifying a mark end");
								return(0);
							}
							$this->AddResultDataPart($output,"</a>");
							$this->mark=0;
							break;
						case "SET":
							$scope=$result[$part]["Data"]["Context"];
							$property=$result[$part]["Data"]["Property"];
							$this->properties[$scope][$property]=$result[$part]["Data"]["Value"];
							break;
						case "GET":
							$scope=$result[$part]["Data"]["Context"];
							$property=$result[$part]["Data"]["Property"];
							if(!IsSet($this->properties[$scope][$property]))
							{
								$compiler->SetElementError($context->file,$context->path,"it was not defined HTML $scope $property PROPERTY");
								return(0);
							}
							$this->AddResultDataPart($output,$this->properties[$scope][$property]);
						case "IMAGE":
							$this->AddResultDataPart($output,"<img".(IsSet($result[$part]["Data"]["AlternativeText"]) ? " alt=\"".HtmlEntities($result[$part]["Data"]["AlternativeText"])."\"" : "")." src=\"".$result[$part]["Data"]["File"]."\"".(GetType($size=@GetImageSize($result[$part]["Data"]["File"]))=="array" ? " width=\"".$size[0]."\" height=\"".$size[1]."\"" : "")."/>");
							break;
						default:
							$compiler->SetElementError($context->file,$context->path,$result[$part]["Data"]["Type"]." is not a supported HTML document element expression type");
							return(0);
					}
					break;
				case "DATA":
					if($this->encode)
					{
						$this->AddResultDataPart($output,HtmlEntities($result[$part]["Data"]));
						break;
					}
				default:
					$output[]=$result[$part];
					break;
			}
		}
		return(1);
	}

	Function GetHeaderFooter(&$compiler,&$context,$file,$path,&$data,$error)
	{	
		$result_data=array();
		if(!$compiler->GetOutputData($file,$path,$result_data,$error,1))
			return(0);
		for($data="",$part=0;$part<count($result_data);$part++)
		{
			switch($result_data[$part]["Type"])
			{
				case "INITIALIZATION":
				case "FILE":
					$context->result[]=$result_data[$part];
					break;
				case "DATA":
					$data.=$result_data[$part]["Data"];
					break;
				default:
					$compiler->SetElementError($file,$path,$error);
					return(0);
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($compiler->language["name"])
		{
			case "PHP":
			case "Java":
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the HTML class");
				return(0);
		}
		switch($function)
		{
			case "output":
				$types=array(
				);
				$optional_types=array(
					"inputfile"=>"DATA",
					"outputfile"=>"DATA",
					"header"=>"CONTEXT",
					"footer"=>"CONTEXT",
				);
				$values=array();
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"database",$function,1))
					return(0);
				if(IsSet($values["outputfile"])
				&& !strcmp($values["outputfile"],""))
				{
					$compiler->SetElementError($arguments->file,$arguments->path,"it was not specified a valid HTML output file name");
					return(0);
				}
				if(IsSet($values["inputfile"]))
				{
					if(!$compiler->ExecuteOutputFile($values["inputfile"],$result,0))
						return(0);
					$context->result[]=array(
						"Data"=>array(
							"Name"=>$values["inputfile"],
							"Type"=>"DEPENDENCY"
						),
						"Type"=>"FILE"
					);
				}
				else
				{
					if(!$compiler->GetOutputData($context->file,$context->path,$result,"invalid html output",1))
						return(0);
				}
				if(IsSet($values["header"]))
				{
					if(!$this->GetHeaderFooter($compiler,$context,$values["header"]->file,$values["header"]->path,$this->header,"it was not specified valid document header data"))
						return(0);
				}
				else
					$this->header="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n<html>\n<head>\n<title></title>\n</head>\n<body>\n";
				if(IsSet($values["footer"]))
				{
					if(!$this->GetHeaderFooter($compiler,$context,$values["footer"]->file,$values["footer"]->path,$this->footer,"it was not specified valid document footer data"))
						return(0);
				}
				else
					$this->footer="</body>\n</html>\n";					
				$this->encode=0;
				$this->lists=0;
				$this->paragraph="";
				$this->mark=
				$this->link=
				$this->monospaced=
				$this->bold=
				$this->italic=
				$this->list_item=
				$this->document_start=
				$this->document_end=
				$this->body_start=
				$this->body_end=0;
				if(IsSet($values["outputfile"]))
				{
					if(!$this->OutputResult($compiler,$context,$result,$output_result,0,count($result)))
						return(0);
				}
				else
				{
					if(!$this->OutputResult($compiler,$context,$result,$context->result,0,count($result)))
						return(0);
				}
				if(!$this->document_start)
				{
					$compiler->SetElementError($context->file,$context->path,"the document start was not specified");
					return(0);
				}
				if(!$this->document_end)
				{
					$compiler->SetElementError($context->file,$context->path,"the document end was not specified");
					return(0);
				}
				if(!IsSet($values["outputfile"]))
					break;
				$result=array();
				if(!$compiler->GenerateOutput($context,$output_result,$output_data,"",0)
				|| !$compiler->CreateContextOutputDirectory(dirname($values["outputfile"]),$context,"it was not possible to create the directory for the output file \"".dirname($values["outputfile"])."\""))
					return(0);
				if(!($output_file=@fopen($values["outputfile"],"w")))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not possible to open the HTML output file \"".$values["outputfile"]."\"");
					return(0);
				}
				$written=fwrite($output_file,$output_data);
				$closed=fclose($output_file);
				if($written!=strlen($output_data)
				|| !$closed)
				{
					$compiler->SetElementError($context->file,$context->path,"it was not possible to write to the HTML output file");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$values["outputfile"],
						"Type"=>"GENERATED"
					),
					"Type"=>"FILE"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported html object function");
				return(0);
		}
		return(1);
	}

};
 
}
?>