<?
if(!defined("METAL_IMAGE_INCLUDED"))
{
	define("METAL_IMAGE_INCLUDED",1);

/*
 * metal_image.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_image.php,v 1.6 2004/05/11 02:19:34 mlemos Exp $
 *
 */
 
class metal_image_class extends metal_base_class
{
	var $base_path="";
	var $attributes=array(
		"file"=>"SRC",
		"align"=>"ALIGN",
		"alternativetext"=>"ALT"
	);

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "basepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$this->base_path,"it was not specified a valid image base path"))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported image object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the image class");
			return(0);
		}
		switch($function)
		{
			case "output":
				$output=array();
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						if(IsSet($this->attributes[$data["Tag"]]))
						{
							$attribute=$this->attributes[$data["Tag"]];
							if(IsSet($output[$attribute]))
							{
								$compiler->SetElementError($context->file,$element_path,"it was specified the image object $attribute argument more than once");
								return(0);
							}
							if(strcmp($attribute,"SRC"))
							{
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression(&$evaluate_context,"STRING","it was not specified a valid image ".$data["Tag"]." argument")
								|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$output[$attribute],&$expression_type))
									return(0);
							}
							else
							{
								if(!$compiler->GetValidData($context->file,$element_path,&$output[$attribute],"it was not specified a valid image file argument"))
									return(0);
								if(!file_exists($output["SRC"]))
								{
									$compiler->SetElementError($context->file,$element_path,"it was not specified an existing image file to output (\"".$output["SRC"]."\")");
									return(0);
								}
							}
						}
						else
						{
							$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported image object output parameter");
							return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($output["SRC"]))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not a specified the image object file name argument");
					return(0);
				}
				$image="\"<IMG SRC=\\\"".$compiler->RelativePath($this->base_path,$output["SRC"])."\\\"";
				$size=GetImageSize($output["SRC"]);
				if($size[2]!=0)
					$image.=" WIDTH=".$size[0]." HEIGHT=".$size[1];
				if(IsSet($output["ALIGN"]))
					$image.=" ALIGN=\\\"\".".$output["ALIGN"].".\"\\\"";
				if(IsSet($output["ALT"]))
					$image.=" ALT=\\\"\".".$output["ALT"].".\"\\\"";
				$image.=">\"";
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$output["SRC"],
						"Type"=>"SUPPLIED"
					),
					"Type"=>"FILE"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$image,
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported image object function");
				return(0);
		}
		return(1);
	}

};
 
}
?>