<?
if(!defined("METAL_MENU_INCLUDED"))
{
	define("METAL_MENU_INCLUDED",1);

/*
 * metal_menu.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_menu.php,v 1.8 2004/05/11 02:19:34 mlemos Exp $
 *
 */
 
class metal_menu_class extends metal_base_class
{
	var $menus_class_file="menus.php";
	var $forms_class_file="forms.php";
	var $menus_class_base_path="";
	var $forms_class_base_path="";
	var $properties=array(
		"method"=>array(array(
			"Data"=>array(
				"Value"=>"\"POST\"",
				"Type"=>"STRING",
				"Side"=>"RIGHT"
			),
			"Type"=>"EXPRESSION"
		)),
		"action"=>array(array(
			"Data"=>array(
				"Value"=>"\$GLOBALS[\"PHP_SELF\"]",
				"Type"=>"STRING",
				"Side"=>"RIGHT"
			),
			"Type"=>"EXPRESSION"
		))
	);
	var $item_attributes=array(
		"label"=>array(
			"Type"=>"STRING",
			"Attribute"=>"Label"
		),
		"id"=>array(
			"Type"=>"STRING",
			"Attribute"=>"ID"
		),
		"accesskey"=>array(
			"Type"=>"STRING",
			"Attribute"=>"ACCESSKEY"
		),
		"href"=>array(
			"Type"=>"STRING",
			"Attribute"=>"HREF"
		),
		"name"=>array(
			"Type"=>"STRING",
			"Attribute"=>"Name"
		),
		"active"=>array(
			"Type"=>"BOOLEAN",
			"Attribute"=>"Active"
		)
	);

	Function SetupItemLevel(&$compiler,&$code,&$context,$path,&$attributes,&$item)
	{
		$elements=$code->structure[$path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				$attribute=$data["Tag"];
				if(!IsSet($attributes[$attribute]))
				{
					$compiler->SetElementError($context->file,$element_path,$attribute." is not a supported menu item attribute");
					return(0);
				}
				if(strcmp($type=$attributes[$attribute]["Type"],"LIST"))
				{
					if(IsSet($item[$attribute]))
					{
						$compiler->SetElementError($context->file,$element_path,"it was specified the ".$attribute." attribute of an already defined menu item field");
						return(0);
					}
					$compiler->CopyEmptyContext($context,$evaluate_context);
					$evaluate_context->path=$element_path;
					if(!$compiler->GetValidTypedExpression(&$evaluate_context,$type,"it was not specified a valid menu item ".$attribute." expression"))
						return(0);
					if(IsSet($attributes[$attribute]["Attribute"]))
						$attribute=$attributes[$attribute]["Attribute"];
					$item[$attribute]=$evaluate_context->result;
				}
				else
				{
					if(!$this->SetupItemLevel(&$compiler,&$code,&$context,$element_path,&$attributes[$attribute]["Attributes"],&$item))
						return(0);
					if(IsSet($attributes[$attribute]["Attribute"]))
					{
						$item[$attributes[$attribute]["Attribute"]]=array(array(
							"Data"=>array(
								"Value"=>1,
								"Type"=>"BOOLEAN",
								"Side"=>"RIGHT"
							),
							"Type"=>"EXPRESSION"
						));
					}
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function SetupItem(&$compiler,&$code,&$context,&$item)
	{
		$item=array();
		return($this->SetupItemLevel(&$compiler,&$code,&$context,$context->path,&$this->item_attributes,&$item));
	}

	Function Setup(&$compiler,&$code,&$attributes)
	{
		$elements=$code->structure[$attributes->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$attributes->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "name":
					case "action":
					case "method":
					case "validationerrormessage":
						$type="STRING";
						$evaluate_context=$attributes;
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidTypedExpression(&$evaluate_context,$type,"it was not specified a valid menu ".$data["Tag"]." expression"))
							return(0);
						$this->properties[$data["Tag"]]=$evaluate_context->result;
						break;
					case "values":
						$type="HASH";
						$evaluate_context=$attributes;
						$evaluate_context->path=$element_path;
						if(!$compiler->GetValidTypedExpression(&$evaluate_context,$type,"it was not specified a valid menu ".$data["Tag"]." expression"))
							return(0);
						$this->properties[$data["Tag"]]=$evaluate_context->result;
						break;
					case "menusclassfile":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$class_file,"it was not specified a valid menus class file"))
							return(0);
						if(!file_exists($class_file))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified a valid an existing menus class file (\"$class_file\")");
							return(0);
						}
						$this->menus_class_file=$class_file;
						break;
					case "menusclassbasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$this->menus_class_base_path,"it was not specified a valid menus class base path"))
							return(0);
						break;
					case "formsclassfile":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$class_file,"it was not specified a valid forms class file"))
							return(0);
						if(!file_exists($class_file))
						{
							$compiler->SetElementError($attributes->file,$element_path,"it was not specified a valid an existing forms class file (\"$class_file\")");
							return(0);
						}
						$this->forms_class_file=$class_file;
						break;
					case "formsclassbasepath":
						if(!$compiler->GetValidData($attributes->file,$element_path,&$this->forms_class_base_path,"it was not specified a valid forms class base path"))
							return(0);
						break;
					default:
						$compiler->SetElementError($attributes->file,$element_path,$data["Tag"]." is not a supported menu object attribute");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($attributes->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function OutputMethodArray(&$compiler,&$context,&$array,$method,$object)
	{
		$context->result[]=array(
			"Data"=>$object."->".$method."(array(",
			"Type"=>"COMMAND"
		);
		$context->result[]=array(
			"Data"=>1,
			"Type"=>"INDENT"
		);
		for($argument=0,Reset($array);$argument<count($array);Next($array),$argument++)
		{
			$argument_name=Key($array);
			if(!$compiler->GetExpressionValue(&$context,&$array[$argument_name],&$argument_expression,&$expression_type))
				return(0);
			$context->result[]=array(
				"Data"=>"\"$argument_name\"=>$argument_expression".($argument<count($array)-1 ? "," : ""),
				"Type"=>"COMMAND"
			);
		}
		$context->result[]=array(
			"Data"=>1,
			"Type"=>"OUTDENT"
		);
		$context->result[]=array(
			"Data"=>"));",
			"Type"=>"COMMAND"
		);
		return(1);
	}

	Function FlushPendingData(&$compiler,&$context,&$pending_data,$object)
	{
		if(strlen($pending_data))
		{
			if(!$compiler->ConvertData($context,"STRING",$pending_data,&$data_part))
				return(0);
			$context->result[]=array(
				"Data"=>$object."->AddDataPart($data_part);",
				"Type"=>"COMMAND"
			);
			$pending_data="";
		}
		return(1);
	}

	Function GetObject(&$compiler,&$context,$element_path,&$object)
	{
		if(strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$element_path,"it was specified the menu object argument");
			return(0);
		}
		$compiler->CopyEmptyContext($context,$evaluate_context);
		$evaluate_context->path=$element_path;
		if(!$compiler->GetValidExpression(&$evaluate_context,"OBJECT","NOTRIGHT","it was not specified a valid menu object expression",1)
		|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$object,&$expression_type))
			return(0);
		return(1);
	}

	Function GetMenuArguments(&$compiler,&$code,&$context,&$object)
	{
		$elements=$code->structure[$context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$context->path.",$element";
			$data=$code->structure[$element_path];
			if(GetType($data)=="array")
			{
				switch($data["Tag"])
				{
					case "object":
						if(!$this->GetObject(&$compiler,&$context,$element_path,&$object))
							return(0);
						break;
					default:
						$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported menu argument");
						return(0);
				}
			}
			else
			{
				if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
					return(0);
			}
		}
		return(1);
	}

	Function VerifyMenuArguments(&$compiler,&$code,&$context,&$object)
	{
		$object="";
		if(!$this->GetMenuArguments(&$compiler,&$code,&$context,&$object))
			return(0);
		If(!strcmp($object,""))
		{
			$compiler->SetElementError($context->file,$context->path,"it was not specified the menu object argument");
			return(0);
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the menu class");
			return(0);
		}
		switch($function)
		{
			case "new":
				if(!$this->VerifyMenuArguments(&$compiler,&$arguments_code,&$arguments,&$object)
				|| (IsSet($this->properties["name"])
				&& !$compiler->GetExpressionValue(&$context,&$this->properties["name"],&$name,&$expression_type))
				|| !$compiler->GetExpressionValue(&$context,&$this->properties["method"],&$method,&$expression_type)
				|| !$compiler->GetExpressionValue(&$context,&$this->properties["action"],&$action,&$expression_type)
				|| (IsSet($this->properties["validationerrormessage"])
				&& !$compiler->GetExpressionValue(&$context,&$this->properties["validationerrormessage"],&$validation_error_message,&$expression_type))
				|| (IsSet($this->properties["values"])
				&& !$compiler->GetExpressionValue(&$context,&$this->properties["values"],&$values,&$expression_type)))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>$object."=new menu_class;",
					"Type"=>"COMMAND"
				);
				if(IsSet($this->properties["name"]))
				{
					$context->result[]=array(
						"Data"=>$object."->NAME=$name;",
						"Type"=>"COMMAND"
					);
				}
				$context->result[]=array(
					"Data"=>$object."->METHOD=$method;",
					"Type"=>"COMMAND"
				);
				$context->result[]=array(
					"Data"=>$object."->ACTION=$action;",
					"Type"=>"COMMAND"
				);
				if(IsSet($this->properties["validationerrormessage"]))
				{
					$context->result[]=array(
						"Data"=>$object."->validation_error_message=$validation_error_message;",
						"Type"=>"COMMAND"
					);
				}
				if(IsSet($this->properties["values"]))
				{
					$context->result[]=array(
						"Data"=>$object."->values=$values;",
						"Type"=>"COMMAND"
					);
				}
				break;
			case "additem":
				if(!$this->VerifyMenuArguments(&$compiler,&$arguments_code,&$arguments,&$object)
				|| !$this->SetupItem(&$compiler,&$code,&$context,&$item))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				if(!$this->OutputMethodArray(&$compiler,&$context,&$item,"AddItem",$object))
					return(0);
				break;
			case "compose":
				Unset($object);
				$skip_white_space=0;
				$elements=$arguments_code->structure[$arguments->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$arguments->path.",$element";
					$data=$arguments_code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "object":
								if(!$this->GetObject(&$compiler,&$arguments,$element_path,&$object))
									return(0);
								break;
							case "skipwhitespace":
								if(!$compiler->GetValidData($arguments->file,$element_path,&$skip_white_space,"it was not specified a valid menu compose skipwhitespace option"))
									return(0);
								if(strcmp($skip_white_space,"1")
								&& strcmp($skip_white_space,"0"))
								{
									$compiler->SetElementError($arguments->file,$element_path,"it was not specified a valid boolean menu compose skipwhitespace option value");
									return(0);
								}
								$skip_white_space=intval($skip_white_space);
								break;
							default:
								$compiler->SetElementError($arguments->file,$element_path,$data["Tag"]." is not a supported menu object compose argument");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($arguments->file,$data,$element_path))
							return(0);
					}
				}
				If(!IsSet($object))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not specified the menu object argument");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$elements=$code->structure[$context->path]["Elements"];
				for($pending_data="",$element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "item":
								if(!$this->FlushPendingData(&$compiler,&$context,&$pending_data,$object))
									return(0);
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression(&$evaluate_context,"STRING","it was not specified a valid menu item name expression")
								|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$name,&$expression_type))
									return(0);
								$context->result[]=array(
									"Data"=>$object."->AddItemPart($name);",
									"Type"=>"COMMAND"
								);
								break;
							case "inputlabel":
							case "submitlabel":
								if(!$this->FlushPendingData(&$compiler,&$context,&$pending_data,$object))
									return(0);
								$label=array();
								$label_elements=$code->structure[$element_path]["Elements"];
								for($label_element=0;$label_element<$label_elements;$label_element++)
								{
									$label_element_path=$element_path.",$label_element";
									$compose_data=$code->structure[$label_element_path];
									if(GetType($compose_data)=="array")
									{
										switch($compose_data["Tag"])
										{
											case "accesskey":
											case "label":
												if(IsSet($label[$compose_data["Tag"]]))
												{
													$compiler->SetElementError($context->file,$label_element_path,"it was specified the ".$compose_data["Tag"]." attribute of an already defined menu $function");
													return(0);
												}
												$compiler->CopyEmptyContext($context,$evaluate_context);
												$evaluate_context->path=$label_element_path;
												if(!$compiler->GetValidTypedExpression(&$evaluate_context,"STRING","it was not specified a valid menu $function ".$compose_data["Tag"]." expression"))
													return(0);
												$label[strtoupper($compose_data["Tag"])]=$evaluate_context->result;
												break;
											default:
												$compiler->SetElementError($context->file,$label_element_path,$compose_data["Tag"]." is not a supported menu $function attribute");
												return(0);
										}
									}
									else
									{
										if(!$compiler->CheckWhiteSpace($context->file,$compose_data,$label_element_path))
											return(0);
									}
								}
								if(!$this->OutputMethodArray(&$compiler,&$context,&$label,$data["Tag"]=="inputlabel" ? "AddInputLabelPart" : "AddSubmitLabelPart",$object))
									return(0);
								break;
							case "input":
								if(!$this->FlushPendingData(&$compiler,&$context,&$pending_data,$object))
									return(0);
								$context->result[]=array(
									"Data"=>$object."->AddInputPart(array());",
									"Type"=>"COMMAND"
								);
								break;
							case "submit":
								if(!$this->FlushPendingData(&$compiler,&$context,&$pending_data,$object))
									return(0);
								$label=array();
								$label_elements=$code->structure[$element_path]["Elements"];
								for($label_element=0;$label_element<$label_elements;$label_element++)
								{
									$label_element_path=$element_path.",$label_element";
									$compose_data=$code->structure[$label_element_path];
									if(GetType($compose_data)=="array")
									{
										switch($compose_data["Tag"])
										{
											case "label":
												if(IsSet($label[$compose_data["Tag"]]))
												{
													$compiler->SetElementError($context->file,$label_element_path,"it was specified the ".$compose_data["Tag"]." attribute of an already defined menu submit");
													return(0);
												}
												$compiler->CopyEmptyContext($context,$evaluate_context);
												$evaluate_context->path=$label_element_path;
												if(!$compiler->GetValidTypedExpression(&$evaluate_context,"STRING","it was not specified a valid menu submit ".$compose_data["Tag"]." expression"))
													return(0);
												$label[strtoupper($compose_data["Tag"])]=$evaluate_context->result;
												break;
											default:
												$compiler->SetElementError($context->file,$label_element_path,$compose_data["Tag"]." is not a supported menu submit attribute");
												return(0);
										}
									}
									else
									{
										if(!$compiler->CheckWhiteSpace($context->file,$compose_data,$label_element_path))
											return(0);
									}
								}
								if(!$this->OutputMethodArray(&$compiler,&$context,&$label,"AddSubmitPart",$object))
									return(0);
								break;
							case "data":
								if(!$compiler->GetOutputData($context->file,$element_path,&$compose_data,"it was not specified valid menu compose data",1))
									return(0);
								for($part=0;$part<count($compose_data);$part++)
								{
									switch($compose_data[$part]["Type"])
									{
										case "DATA":
											if(strlen($compose_data[$part]["Data"]))
												$pending_data.=$compose_data[$part]["Data"];
											break;
										case "EXPRESSION":
											if(!$this->FlushPendingData(&$compiler,&$context,&$pending_data,$object))
												return(0);
											$expression=array($compose_data[$part]);
											if(!$compiler->GetExpressionValue(&$context,&$expression,&$expression_value,&$expression_type))
												return(0);
											$context->result[]=array(
												"Data"=>$object."->AddDataPart($expression_value);",
												"Type"=>"COMMAND"
											);
											break;
										default:
											if(!$this->FlushPendingData(&$compiler,&$context,&$pending_data,$object))
												return(0);
											$context->result[]=$compose_data[$part];
											break;
									}
								}
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$compose_data["Tag"]." is not a supported menu object compose argument");
								return(0);
						}
					}
					else
					{
						if(strlen($data))
						{
							if($skip_white_space)
							{
								if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
									return(0);
							}
							else
								$pending_data.=$data;
						}
					}
				}
				if(!$this->FlushPendingData(&$compiler,&$context,&$pending_data,$object))
					return(0);
				break;
			case "output":
				if(!$this->VerifyMenuArguments(&$compiler,&$arguments_code,&$arguments,&$object))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>"MenuCaptureOutput($object,array(\"EndOfLine\"=>\"\\n\"))",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			case "validate":
				if(!$this->VerifyMenuArguments(&$compiler,&$arguments_code,&$arguments,&$object))
					return(0);
				Unset($verify_expression);
				$elements=$code->structure[$context->path]["Elements"];
				for($element=0;$element<$elements;$element++)
				{
					$element_path=$context->path.",$element";
					$data=$code->structure[$element_path];
					if(GetType($data)=="array")
					{
						switch($data["Tag"])
						{
							case "page":
								$compiler->CopyEmptyContext($context,$evaluate_context);
								$evaluate_context->path=$element_path;
								if(!$compiler->GetValidTypedExpression(&$evaluate_context,"STRING","it was not specified a valid menu validate page expression")
								|| !$compiler->GetExpressionValue(&$context,&$evaluate_context->result,&$page_expression,&$expression_type))
									return(0);
								break;
							default:
								$compiler->SetElementError($context->file,$element_path,$data["Tag"]." is not a supported menu object validate parameter");
								return(0);
						}
					}
					else
					{
						if(!$compiler->CheckWhiteSpace($context->file,$data,$element_path))
							return(0);
					}
				}
				if(!IsSet($page_expression))
				{
					$compiler->SetElementError($context->file,$context->path,"it was not a specified the menu object validate page argument");
					return(0);
				}
				$context->result[]=array(
					"Data"=>array(
						"Object"=>$this->object_name,
						"Context"=>""
					),
					"Type"=>"INITIALIZATION"
				);
				$context->result[]=array(
					"Data"=>array(
						"Value"=>$object."->Validate($page_expression)",
						"Type"=>"STRING",
						"Side"=>"RIGHT"
					),
					"Type"=>"EXPRESSION"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$function." is not a supported menu object function");
				return(0);
		}
		return(1);
	}

	Function Initialization(&$compiler,&$context,$object_context)
	{
		if(strcmp($compiler->language["name"],"PHP"))
		{
			$compiler->SetElementError($context->file,$context->path,$compiler->language["name"]." is not a language supported by the menu class");
			return(0);
		}
		$relative_path=$compiler->RelativePath($this->forms_class_base_path,$this->forms_class_file);
		$context->result[]=array(
			"Data"=>array(
				"Name"=>$this->forms_class_file,
				"Type"=>"SUPPLIED"
			),
			"Type"=>"FILE"
		);
		$context->result[]=array(
			"Data"=>"require(\"$relative_path\");",
			"Type"=>"COMMAND"
		);
		$relative_path=$compiler->RelativePath($this->menus_class_base_path,$this->menus_class_file);
		$context->result[]=array(
			"Data"=>array(
				"Name"=>$this->menus_class_file,
				"Type"=>"SUPPLIED"
			),
			"Type"=>"FILE"
		);
		$context->result[]=array(
			"Data"=>"require(\"$relative_path\");",
			"Type"=>"COMMAND"
		);
		return(1);
	}

};
 
}
?>