<?php
if(!defined("METAL_PERSISTENCE_SCHEMA_GENERATOR_INCLUDED"))
{
	define("METAL_PERSISTENCE_SCHEMA_GENERATOR_INCLUDED",1);

/*
 * metal_persistence_schema_generator.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_persistence_schema_generator.php,v 1.13 2005/09/11 23:19:17 mlemos Exp $
 *
 */

class metal_persistence_schema_generator_class
{
	Function Generate(&$module,&$compiler,&$context)
	{
		$database=$compiler->GetXMLNode();
		$tables=array();
		$component=$module->component_name;
		Reset($module->components[$component]["classes"]);
		for(;GetType($class=Key($module->components[$component]["classes"]))=="string";Next($module->components[$component]["classes"]))
		{
			$fields=array();
			$declaration=$compiler->GetXMLNode();

			$fields[]=array(
				"Data"=>array(
					"TemplateFile"=>"template/persistence/schema/field.xml",
					"Parent"=>$declaration,
					"Variables"=>array(
						"name"=>array(
							array(
								"Data"=>"id",
								"Type"=>"DATA"
							)
						)
					),
					"Tags"=>array(
						"field"=>array(
							"Tag"=>"field"
						),
					),
					"Conditional"=>array(
						"autoincrement"=>array(
							array(
								"Data"=>"1",
								"Type"=>"DATA"
							)
						),
						"type"=>array(),
						"notnull"=>array(),
						"default"=>array(),
						"was"=>array(),
						"length"=>array(),
					)
				),
				"Type"=>"XMLTEMPLATE"
			);
			$defaults=array(
				"boolean"=>"0",
				"date"=>"2000-01-01",
				"decimal"=>"0",
				"integer"=>"0",
				"float"=>"0",
				"text"=>"",
				"time"=>"00:00:00",
				"timestamp"=>"2000-01-01 00:00:00"
			);
			Reset($module->components[$component]["classes"][$class]["variables"]);
			for(;GetType($variable=Key($module->components[$component]["classes"][$class]["variables"]))=="string";Next($module->components[$component]["classes"][$class]["variables"]))
			{
				$was=$notnull=$length=$default=array();
				if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["type"]))
				{
					$type=$module->components[$component]["classes"][$class]["variables"][$variable]["type"];
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["length"]))
					{
						$length=array(
							array(
								"Data"=>$module->components[$component]["classes"][$class]["variables"][$variable]["length"],
								"Type"=>"DATA"
							)
						);
					}
					if(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["initialvalue"]))
					{
						$default=array(
							array(
								"Data"=>$module->components[$component]["classes"][$class]["variables"][$variable]["initialvalue"],
								"Type"=>"DATA"
							)
						);
					}
					elseif(!IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["optional"]))
					{
						$default=array(
							array(
								"Data"=>$defaults[$type],
								"Type"=>"DATA"
							)
						);
					}
					$notnull=array(
						array(
							"Data"=>(IsSet($module->components[$component]["classes"][$class]["variables"][$variable]["optional"]) ? "0" : "1"),
							"Type"=>"DATA"
						)
					);
				}
				else
					$type="integer";
				$fields[]=array(
					"Data"=>array(
						"TemplateFile"=>"template/persistence/schema/field.xml",
						"Parent"=>$declaration,
						"Variables"=>array(
							"name"=>array(
								array(
									"Data"=>$variable,
									"Type"=>"DATA"
								)
							)
						),
						"Tags"=>array(
							"field"=>array(
								"Tag"=>"field"
							),
						),
						"Conditional"=>array(
							"autoincrement"=>array(),
							"type"=>array(
								array(
									"Data"=>$type,
									"Type"=>"DATA"
								)
							),
							"notnull"=>$notnull,
							"default"=>$default,
							"was"=>$was,
							"length"=>$length,
						)
					),
					"Type"=>"XMLTEMPLATE"
				);
			}
			$tables[]=array(
				"Data"=>array(
					"TemplateFile"=>"template/persistence/schema/table.xml",
					"Parent"=>$database,
					"Variables"=>array(
						"fields"=>$fields,
						"name"=>array(
							array(
								"Data"=>$class,
								"Type"=>"DATA"
							)
						)
					),
					"Tags"=>array(
						"declaration"=>array(
							"Tag"=>"declaration",
							"Node"=>$declaration,
							"Spacing"=>1,
							"Indent"=>1
						),
					),
					"Conditional"=>array(
						"primarykey"=>array(
						)
					)
				),
				"Type"=>"XMLTEMPLATE"
			);
			Reset($module->components[$component]["classes"][$class]["collections"]);
			for(;GetType($collection=Key($module->components[$component]["classes"][$class]["collections"]))=="string";Next($module->components[$component]["classes"][$class]["collections"]))
			{
				$collection_class=$module->components[$component]["classes"][$class]["collections"][$collection]["class"];
				$collection_reference=$module->components[$component]["classes"][$class]["collections"][$collection]["reference"];
				$collection_component=(IsSet($module->components[$component]["classes"][$class]["collections"][$collection]["component"]) ? $module->components[$component]["classes"][$class]["collections"][$collection]["component"] : $component);
				if(IsSet($module->components[$collection_component]["classes"][$collection_class]["collections"][$collection_reference])
				&& (strcmp($class,$collection_class)<0
				|| (strcmp($class,$collection_class)==0
				&& strcmp($collection,$collection_reference)<0)))
				{
					$declaration=$compiler->GetXMLNode();
					$fields=array();
					$fields[]=array(
						"Data"=>array(
							"TemplateFile"=>"template/persistence/schema/field.xml",
							"Parent"=>$declaration,
							"Variables"=>array(
								"name"=>array(
									array(
										"Data"=>$class."_".$collection,
										"Type"=>"DATA"
									)
								)
							),
							"Tags"=>array(
								"field"=>array(
									"Tag"=>"field"
								),
							),
							"Conditional"=>array(
								"autoincrement"=>array(),
								"type"=>array(
									array(
										"Data"=>"integer",
										"Type"=>"DATA"
									)
								),
								"notnull"=>array(
									array(
										"Data"=>"1",
										"Type"=>"DATA"
									)
								),
								"default"=>array(
									array(
										"Data"=>"0",
										"Type"=>"DATA"
									)
								),
								"was"=>array(
									array(
										"Data"=>$class,
										"Type"=>"DATA"
									)
								),
								"length"=>array(),
							)
						),
						"Type"=>"XMLTEMPLATE"
					);
					$fields[]=array(
						"Data"=>array(
							"TemplateFile"=>"template/persistence/schema/field.xml",
							"Parent"=>$declaration,
							"Variables"=>array(
								"name"=>array(
									array(
										"Data"=>$collection_class."_".$collection_reference,
										"Type"=>"DATA"
									)
								)
							),
							"Tags"=>array(
								"field"=>array(
									"Tag"=>"field"
								),
							),
							"Conditional"=>array(
								"autoincrement"=>array(),
								"type"=>array(
									array(
										"Data"=>"integer",
										"Type"=>"DATA"
									)
								),
								"notnull"=>array(
									array(
										"Data"=>"1",
										"Type"=>"DATA"
									)
								),
								"default"=>array(
									array(
										"Data"=>"0",
										"Type"=>"DATA"
									)
								),
								"was"=>array(
									array(
										"Data"=>$collection_class,
										"Type"=>"DATA"
									)
								),
								"length"=>array(),
							)
						),
						"Type"=>"XMLTEMPLATE"
					);
					$primary_key=$compiler->GetXMLNode();
					$primary_key_fields[]=array(
						"Data"=>array(
							"Parent"=>$primary_key,
							"Node"=>($field=$compiler->GetXMLNode()),
							"Tag"=>"field",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$primary_key_fields[]=array(
						"Data"=>array(
							"Parent"=>$field,
							"Tag"=>"name",
							"Data"=>$class."_".$collection
						),
						"Type"=>"XMLTAG"
					);
					$primary_key_fields[]=array(
						"Data"=>array(
							"Node"=>($field=$compiler->GetXMLNode()),
							"Parent"=>$primary_key,
							"Tag"=>"field",
							"Indent"=>1
						),
						"Type"=>"XMLTAG"
					);
					$primary_key_fields[]=array(
						"Data"=>array(
							"Parent"=>$field,
							"Tag"=>"name",
							"Data"=>$collection_class."_".$collection_reference
						),
						"Type"=>"XMLTAG"
					);
					$tables[]=array(
						"Data"=>array(
							"TemplateFile"=>"template/persistence/schema/table.xml",
							"Parent"=>$database,
							"Variables"=>array(
								"fields"=>$fields,
								"name"=>array(
									array(
										"Data"=>$class."_".$collection."_".$collection_class."_".$collection_reference,
										"Type"=>"DATA"
									)
								),
								"primarykeyfields"=>$primary_key_fields
							),
							"Tags"=>array(
								"declaration"=>array(
									"Tag"=>"declaration",
									"Node"=>$declaration,
									"Spacing"=>1,
									"Indent"=>1
								),
								"primarykey"=>array(
									"Node"=>$primary_key,
									"Tag"=>"primarykey"
								)
							),
						),
						"Type"=>"XMLTEMPLATE"
					);
				}
			}
		}
		$context->result[]=array(
			"Data"=>array(
				"TemplateFile"=>"template/persistence/schema/database.xml",
				"Variables"=>array(
					"tables"=>$tables,
				),
				"Tags"=>array(
					"database"=>array(
						"Node"=>$database,
						"Tag"=>"database",
					),
				)
			),
			"Type"=>"XMLTEMPLATE"
		);
	}

	Function GenerateClassVariables(&$module,&$compiler,&$context,$class_node)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"error"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"STRING"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"connection"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"STRING"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"includepath"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"STRING"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"schemapath"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"STRING"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"databasename"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"STRING"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value"
			),
			"Type"=>"XMLTAG"
		);

		$context->result[]=array(
			"Data"=>array(
				"Node"=>($variable=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"variable",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"name",
				"Data"=>"createdatabase"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"type",
				"Data"=>"BOOLEAN"
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$variable,
				"Tag"=>"value",
				"Data"=>"1"
			),
			"Type"=>"XMLTAG"
		);
	}

	Function GenerateFunction(&$module,&$compiler,&$context,$component,$class,$function_name,$class_node,$function,&$values,&$function_arguments)
	{
		$context->result[]=array(
			"Data"=>array(
				"Node"=>($function_node=$compiler->GetXMLNode()),
				"Parent"=>$class_node,
				"Tag"=>"function",
				"Indent"=>1
			),
			"Type"=>"XMLTAG"
		);
		$context->result[]=array(
			"Data"=>array(
				"Parent"=>$function_node,
				"Tag"=>"name",
				"Data"=>$function_name
			),
			"Type"=>"XMLTAG"
		);
		switch($function_arguments["type"])
		{
			case "installschema":
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$function_node,
						"Tag"=>"type",
						"Data"=>"BOOLEAN"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($do=$compiler->GetXMLNode()),
						"Parent"=>$function_node,
						"Tag"=>"do",
						"Indent"=>1,
						"Spacing"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($set=$compiler->GetXMLNode()),
						"Parent"=>$do,
						"Tag"=>"set",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$set,
						"Tag"=>"variable",
						"Data"=>"variables"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($hash=$compiler->GetXMLNode()),
						"Parent"=>$set,
						"Tag"=>"hash",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$hash,
						"Tag"=>"string",
						"Data"=>"name"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$hash,
						"Tag"=>"this",
						"Data"=>"databasename"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$hash,
						"Tag"=>"string",
						"Data"=>"create"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$hash,
						"Tag"=>"this",
						"Data"=>"createdatabase"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($set=$compiler->GetXMLNode()),
						"Parent"=>$do,
						"Tag"=>"set",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$set,
						"Tag"=>"variable",
						"Data"=>"manager"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$set,
						"Tag"=>"createdatabasemanager"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($updatedatabase=$compiler->GetXMLNode()),
						"Parent"=>$do,
						"Tag"=>"updatedatabase",
						"Indent"=>1
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($object=$compiler->GetXMLNode()),
						"Parent"=>$updatedatabase,
						"Tag"=>"object"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$object,
						"Tag"=>"variable",
						"Data"=>"manager"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($schema=$compiler->GetXMLNode()),
						"Parent"=>$updatedatabase,
						"Tag"=>"schema"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($stringdata=$compiler->GetXMLNode()),
						"Parent"=>$schema,
						"Tag"=>"stringdata"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$stringdata,
						"Tag"=>"this",
						"Data"=>"schemapath"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$stringdata,
						"Data"=>"/".basename($values["schemafilename"])
					),
					"Type"=>"XMLDATA"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($connection=$compiler->GetXMLNode()),
						"Parent"=>$updatedatabase,
						"Tag"=>"connection"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$connection,
						"Tag"=>"this",
						"Data"=>"connection"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($includepath=$compiler->GetXMLNode()),
						"Parent"=>$updatedatabase,
						"Tag"=>"includepath"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$includepath,
						"Tag"=>"this",
						"Data"=>"includepath"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($variables=$compiler->GetXMLNode()),
						"Parent"=>$updatedatabase,
						"Tag"=>"variables"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$variables,
						"Tag"=>"variable",
						"Data"=>"variables"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($success=$compiler->GetXMLNode()),
						"Parent"=>$updatedatabase,
						"Tag"=>"success"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$success,
						"Tag"=>"booleanvariable",
						"Data"=>"success"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($error=$compiler->GetXMLNode()),
						"Parent"=>$updatedatabase,
						"Tag"=>"error"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$error,
						"Tag"=>"this",
						"Data"=>"error"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Node"=>($return=$compiler->GetXMLNode()),
						"Parent"=>$do,
						"Tag"=>"return"
					),
					"Type"=>"XMLTAG"
				);
				$context->result[]=array(
					"Data"=>array(
						"Parent"=>$return,
						"Tag"=>"variable",
						"Data"=>"success"
					),
					"Type"=>"XMLTAG"
				);
				break;

			default:
				return($compiler->SetElementError($context->file,$context->path,$function_arguments["type"]." is not yet a supported schema class function"));
		}
		return(1);
	}

	Function GenerateClass(&$module, &$compiler, &$context, $component, $values, $function)
	{
		$module->generator->GenerateStorageClass($module,$compiler,$context,$class_node,$component,$component."schemaclass",$values);

		$this->GenerateClassVariables($module,$compiler,$context,$class_node);

		for($schema_function=0,Reset($module->components[$component]["schema"]["functions"]);$schema_function<count($module->components[$component]["schema"]["functions"]);$schema_function++,Next($module->components[$component]["schema"]["functions"]))
		{
			$function_name=Key($module->components[$component]["schema"]["functions"]);
			if(!$this->GenerateFunction($module,$compiler,$context,$component,"schema",$function_name,$class_node,$function,$values,$module->components[$component]["schema"]["functions"][$function_name]))
				return(0);
			if(!$module->VerifyUnusedArguments($compiler,$function_name,$module->components[$component]["schema"]["functions"][$function_name]))
				return(0);
		}
		return(1);
	}

	Function GenerateClassDiagram(&$compiler,&$module,$component,$indent,$linefeed,&$graph)
	{
		$module->generator->StartFormattingDiagramLines();
		$graph.=$indent.$component."schema [label=\"{".$component."schema|";

		$graph.=$module->generator->FormatDiagramLine("+error:string")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+connection:string")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+includepath:string")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+schemapath:string")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+databasename:string")."\\l";
		$graph.=$module->generator->FormatDiagramLine("+createdatabase:boolean")."\\l";

		$graph.="|";

		for($function=0,Reset($module->components[$component]["schema"]["functions"]);$function<count($module->components[$component]["schema"]["functions"]);Next($module->components[$component]["schema"]["functions"]),$function++)
		{
			$current_function=Key($module->components[$component]["schema"]["functions"]);
			$function_type=$arguments="";
			$function_arguments=$module->components[$component]["schema"]["functions"][$current_function];
			switch($module->components[$component]["schema"]["functions"][$current_function]["type"])
			{
				case "installschema":
					$function_type="boolean";
					break;
				default:
					return($compiler->SetElementError($function_arguments["function"]->file,$function_arguments["function"]->path,$module->components[$component]["schema"]["functions"][$current_function]["type"]." is not yet a supported schema class function to generate in the graph"));
			}
			$graph.=$module->generator->FormatDiagramLine("+".$current_function."(".(strlen($arguments) ? " ".$arguments." " : "").")".(strlen($function_type) ? ":".$function_type : ""))."\\l";
		}

		$graph.="}\",color=blue]".$linefeed;
		return(1);
	}
};

}
?>