<?php
if(!defined("METAL_PHP_BINDINGS_INCLUDED"))
{
	define("METAL_PHP_BINDINGS_INCLUDED",1);

/*
 * metal_php_bindings.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_php_bindings.php,v 1.55 2003/03/28 04:57:00 mlemos Exp $
 *
 */
 
class metal_php_bindings_class extends metal_base_bindings_class
{
	var $last_was_command=0;
	var $nesting_level=0;
	var $priorities=array(
		"and"=>1,
		"or"=>1,
		"xor"=>1,
		"less"=>2,
		"lessorequal"=>2,
		"more"=>2,
		"moreorequal"=>2,
		"equal"=>2,
		"different"=>2,
		"equalstrings"=>2,
		"differentstrings"=>2,
		"join"=>3,
		"plus"=>3,
		"minus"=>3,
		"multiply"=>4,
		"integermultiply"=>4,
		"divide"=>4,
		"integerdivide"=>4,
		"integerremainder"=>4
	);

	Function Setup(&$compiler,&$code,&$context)
	{
		$this->last_was_command=0;
		$this->nesting_level=0;
		return(1);
	}

	Function EvaluateOperation(&$compiler,&$context,&$left,&$right,&$operator)
	{
		$left_type=$left["Data"]["Type"];
		$right_type=$right["Data"]["Type"];
		switch($operator["Data"])
		{
			case "less":
			case "lessorequal":
			case "more":
			case "moreorequal":
			case "equal":
			case "equalstrings":
			case "different":
			case "differentstrings":
			case "and":
			case "or":
			case "xor":
			case "plus":
			case "minus":
			case "join":
			case "multiply":
			case "integermultiply":
			case "divide":
			case "integerdivide":
			case "integerremainder":
				switch($operator["Data"])
				{
					case "less":
						$operation="%s<%s";
						$type="INTEGER";
						$result_type="BOOLEAN";
						break;
					case "lessorequal":
						$operation="%s<=%s";
						$type="INTEGER";
						$result_type="BOOLEAN";
						break;
					case "more":
						$operation="%s>%s";
						$type="INTEGER";
						$result_type="BOOLEAN";
						break;
					case "moreorequal":
						$operation="%s>=%s";
						$type="INTEGER";
						$result_type="BOOLEAN";
						break;
					case "equal":
						$operation="%s==%s";
						$type="INTEGER";
						$result_type="BOOLEAN";
						break;
					case "different":
						$operation="%s!=%s";
						$type="INTEGER";
						$result_type="BOOLEAN";
						break;
					case "equalstrings":
						$operation="!strcmp(%s,%s)";
						$type="STRING";
						$result_type="BOOLEAN";
						break;
					case "differentstrings":
						$operation="strcmp(%s,%s)";
						$type="STRING";
						$result_type="BOOLEAN";
						break;
					case "and":
						$operation="%s && %s";
						$type=$result_type="BOOLEAN";
						break;
					case "or":
						$operation="%s || %s";
						$type=$result_type="BOOLEAN";
						break;
					case "xor":
						$operation="%s xor %s";
						$type=$result_type="BOOLEAN";
						break;
					case "plus":
						$operation="%s+%s";
						$type=$result_type="INTEGER";
						break;
					case "minus":
						$operation="%s-%s";
						$type=$result_type="INTEGER";
						break;
					case "join":
						$operation="%s.%s";
						$type=$result_type="STRING";
						break;
					case "multiply":
						$operation="%s*%s";
						$type=$result_type="FLOAT";
						break;
					case "integermultiply":
						$operation="%s*%s";
						$type=$result_type="INTEGER";
						break;
					case "divide":
						$operation="%s/%s";
						$type=$result_type="FLOAT";
						break;
					case "integerdivide":
						$operation="intval(%s/%s)";
						$type=$result_type="INTEGER";
						break;
					case "integerremainder":
						$operation="intval(%s %% %s)";
						$type=$result_type="INTEGER";
						break;
				}
				if(!strcmp($left_type,"ANY"))
					$left_type=$type;
				if(!strcmp($right_type,"ANY"))
					$right_type=$type;
				if(strcmp($left_type,$right_type))
				{
					$compiler->SetElementError($context->file,$context->path,"it were specified expressions of different types ($left_type and $right_type) of values on each side of the operator ".$operator["Data"]);
					return(0);
				}
				if(strcmp($left_type,$type))
				{
					$compiler->SetElementError($context->file,$context->path,"it were specified non-$type expressions for comparision");
					return(0);
				}
				$left["Data"]["Value"]=sprintf($operation,$left["Data"]["Value"],$right["Data"]["Value"]);
				$left["Data"]["Type"]=$result_type;
				$left["Data"]["Side"]="RIGHT";
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$operator["Data"]." is not a supported OPERATOR");
				return(0);
		}
		return(1);
	}

	Function ConvertTypedData(&$compiler,&$context,$type,$data)
	{
		switch($type)
		{
			case "STRING":
				$length=strlen($data);
				for($converted_data="'",$position=0;$position<$length;$position++)
				{
					switch($character=$data[$position])
					{
						case "\\":
							$converted_data.="\\\\";
							break;
						case "'":
							$converted_data.="\\'";
							break;
						default:
							$order=Ord($character);
							if($order<32
							|| $order>127)
								break 2;
							$converted_data.=$character;
							break;
					}
				}
				if($position==$length)
				{
					$converted_data.="'";
					break;
				}
				for($converted_data="\"",$position=0;$position<$length;$position++)
				{
					switch($character=$data[$position])
					{
						case "\r":
							$converted_data.="\\r";
							break;
						case "\n":
							$converted_data.="\\n";
							break;
						case "\t":
							$converted_data.="\\t";
							break;
						case "\$":
							$converted_data.="\\\$";
							break;
						case "\"":
							$converted_data.="\\\"";
							break;
						case "\\":
							$converted_data.="\\\\";
							break;
						default:
							$order=Ord($character);
							if($order<32
							|| $order>127)
								$converted_data.=sprintf("\\%o",$order);
							else
								$converted_data.=$character;
							break;
					}
				}
				$converted_data.="\"";
				break;
			case "INTEGER":
				if(strval(intval($data))!=$data)
				{
					$compiler->SetElementError($context->file,$context->path,"\"$data\" is not a valid INTEGER value");
					return(0);
				}
				$converted_data="$data";
				break;
			case "FLOAT":
				if(strval(doubleval($data))!=$data)
				{
					$compiler->SetElementError($context->file,$context->path,"\"$data\" is not a valid FLOAT value");
					return(0);
				}
				$converted_data="$data";
				break;
			case "BOOLEAN":
				switch(strtolower($data))
				{
					case "1":
					case "true":
						$converted_data="1";
						break;
					case "0":
					case "false":
						$converted_data="0";
						break;
					default:
						$compiler->SetElementError($context->file,$context->path,"\"$data\" is not a valid BOOLEAN value");
						return(0);
				}
				break;
			case "HASH":
			case "ARRAY":
				if(strcmp($data,""))
				{
					$compiler->SetElementError($context->file,$context->path,"\"$data\" is not a valid $type value");
					return(0);
				}
				$converted_data="array()";
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,$type." is not a valid type to be converted from data");
				return(0);
		}
		$context->result[]=array(
			"Data"=>array(
				"Value"=>$converted_data,
				"Type"=>$type,
				"Side"=>"RIGHT"
			),
			"Type"=>"EXPRESSION"
		);
		return(1);
	}

	Function GenerateCommand(&$compiler,&$context,$evaluate,&$output,$indent,&$part)
	{
		if($evaluate)
		{
			$compiler->SetElementError($context->file,$context->path,"evaluation of the output of a command is not supported");
			return(0);
		}
		if(!$this->last_was_command)
			$output.="<?php\n";
		$output.=$indent.$part["Data"]."\n";
		$this->last_was_command=1;
		return(1);
	}

	Function GenerateOutput(&$compiler,&$context,$data,&$output,$indent,$evaluate)
	{
		$compiler->CopyEmptyContext($context,$output_context);
		if(!strcmp($indent,""))
			$indent="\t";
		for($part=0;$part<count($data);$part++)
		{
			switch($data[$part]["Type"])
			{
				case "INITIALIZATION":
					$this->nesting_level++;
					$compiler->CopyEmptyContext($context,$initialization_context);
					$success=$compiler->OutputObjectInitialization($initialization_context,$data[$part]["Data"]["Object"],$data[$part]["Data"]["Context"],$output,$indent,$evaluate);
					$this->nesting_level--;
					if(!$success)
						return(0);
					for($output_part=0;$output_part<count($initialization_context->result);$output_part++)
						$output_context->result[]=$initialization_context->result[$output_part];
					break;
				case "DATA":
					if($this->last_was_command)
						$output.="?>";
					$output.=$data[$part]["Data"];
					$this->last_was_command=0;
					break;
				case "COMMAND":
					if(!$this->GenerateCommand($compiler,$context,$evaluate,$output,$indent,$data[$part]))
						return(0);
					break;
				case "EXPRESSION":
					if($evaluate)
					{
						eval("\$expression=strval(".$data[$part]["Data"]["Value"].");");
						$output.=$expression;
					}
					else
					{
						switch($data[$part]["Data"]["Type"])
						{
							case "STRING":
							case "INTEGER":
							case "FLOAT":
							case "BOOLEAN":
								break;
							default:
								$compiler->SetElementError($context->file,$context->path,$data[$part]["Data"]["Type"]." is not a valid expression type to output");
								return(0);				
						}
						if(!$this->last_was_command)
							$output.="<?php\n";
						$output.=$indent."echo ".$data[$part]["Data"]["Value"].";\n";
						$this->last_was_command=1;
					}
					break;
				case "INDENT":
					for($level=$data[$part]["Data"];$level;$indent.="\t",$level--);
					break;
				case "OUTDENT":
					$indent=substr($indent,0,strlen($indent)-$data[$part]["Data"]);
					break;
				case "DEFERRED":
					$command_data=$data[$part]["Data"];
					$error="it was specified a misplaced ".$command_data["Command"]." command";
					if(IsSet($command_data["File"])
					&& IsSet($command_data["Line"])
					&& IsSet($command_data["Column"])
					&& IsSet($command_data["Byte"]))
						$compiler->SetError($command_data["File"],$command_data["Line"],$command_data["Column"],$command_data["Byte"],$error);
					else
						$compiler->SetElementError($context->file,$context->path,$error);
					return(0);
				case "FILE":
					if(!file_exists($data[$part]["Data"]["Name"]))
					{
						$compiler->SetElementError($context->file,$context->path,"it was specified a ".$data[$part]["Data"]["Type"]." file (\"".$data[$part]["Data"]["Name"]."\") that does not exist");
						return(0);
					}
					$output_context->result[]=$data[$part];
					break;
				case "RESETINDENT":
					$this->indent_stack[count($this->indent_stack)]=$indent;
					for($indent="",$indent_level=$data[$part]["Data"];$indent_level;$indent.="\t",$indent_level--);
					break;
				case "RESTOREINDENT":
					if(count($this->indent_stack)==0)
					{
						$compiler->SetElementError($context->file,$context->path,"it was specified a RESTOREINDENT command when there is no indentation text values on the stack");
						return(0);
					}
					$indent=$this->indent_stack[count($this->indent_stack)-1];
					Unset($this->indent_stack[count($this->indent_stack)-1]);
					break;
				case "CONTROL":
					if($data[$part]["Data"]["Type"]!="FLUSH")
					{
						$compiler->SetElementError($context->file,$context->path,$data[$part]["Data"]["Type"]." is not a supported type of CONTROL");
						return(0);
					}
					$command=array(
						"Data"=>"flush();",
						"Type"=>"COMMAND"
					);
					if(!$this->GenerateCommand($compiler,$context,$evaluate,$output,$indent,$command))
						return(0);
					break;
				default:
					$compiler->SetElementError($context->file,$context->path,$data[$part]["Type"]." is not a supported output type");
					return(0);
			}
		}
		if(!$this->nesting_level
		&& $this->last_was_command)
		{
			$output.="?>";
			$this->last_was_command=0;
		}
		$context->result=$output_context->result;
		return(1);
	}

	Function GetBindingsProperty(&$compiler,&$context,$property,&$value)
	{
		switch($property)
		{
			case "filenameextension":
				$value=".php";
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,"\"$property\" is not a supported bindings property");
				return(0);
		}
		return(1);
	}

	Function GetVariableDeclaration(&$compiler,&$context,&$variable)
	{
		$variable["Declaration"]="\$".((IsSet($variable["Temporary"]) && $variable["Temporary"]) ? $this->temporary_variables_prefix : "").$variable["Name"];
		return(1);
	}
};
 
}
?>