<?php

if(!defined("METAL_XML_INCLUDED"))
{
	define("METAL_XML_INCLUDED",1);

/*
 * metal_xml.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/metal_xml.php,v 1.17 2005/09/11 02:58:26 mlemos Exp $
 *
 */

class metal_xml_class extends metal_base_class
{
	var $structure=array();
	var $nodes=array();
	var $tags=array();
	var $current_node="";
	var $stylesheet="";
	var $stylesheettype="text/xsl";
	var $dtdtype="";
	var $dtddefinition="";
	var $dtdurl="";
	var $outputencoding="iso-8859-1";
	var $indenttext=" ";
	var $linebreak="\n";
	var $error="";
	var $output_file="";
	var $processing_template=0;
	var $node_map=array();

	Function Setup(&$compiler,&$code,&$attributes)
	{
		return(1);
	}

	Function GenerateTag(&$output,$path,$indent)
	{
		$tag=$this->structure[$path]["Tag"];
		$output.=("<".$tag);
		$attributecount=count($this->structure[$path]["Attributes"]);
		if($attributecount>0)
		{
			$attributes=$this->structure[$path]["Attributes"];
			Reset($attributes);
			$end=(GetType($key=Key($attributes))!="string");
			for(;!$end;)
			{
				$output.=(" ".$key."=\"".$attributes[$key]."\"");
				Next($attributes);
				$end=(GetType($key=Key($attributes))!="string");
			}
		}
		$elements=$this->structure[$path]["Elements"];
		if($elements>0)
		{
			$output.=">";
			$doindent=$this->structure[$path]["Indent"];
			$spacing=$this->structure[$path]["Spacing"];
			$elementindent=(($doindent) ? $this->linebreak.$indent.$this->indenttext : "");
			$element=0;
			for(;$element<$elements;)
			{
				for($line=0;$line<$spacing;$line++)
					$output.=$this->linebreak;
				$elementpath=($path.",".strval($element));
				$output.=$elementindent;
				if(IsSet($this->tags[$elementpath]))
				{
					if(!($this->GenerateTag($output,$elementpath,$indent.$this->indenttext)))
						return 0;
				}
				else
					$output.=$this->structure[$elementpath];
				$element++;
			}
			for($line=0;$line<$spacing;$line++)
				$output.=$this->linebreak;
			$output.=((($doindent) ? $this->linebreak.$indent : "")."</".$tag.">");
		}
		else
			$output.="/>";
		return 1;
	}

	Function GenerateDocument(&$output)
	{
		if(strlen($this->error))
			return 0;
		if(!(IsSet($this->structure["0"])))
		{
			$this->error="XML document structure is empty";
			return 0;
		}
		$output=("<?xml version=\"1.0\" encoding=\"".$this->outputencoding."\"?>".$this->linebreak);
		if(strcmp($this->dtdtype,""))
		{
			$output.=("<!DOCTYPE ".$this->structure["0"]["Tag"]." ");
			switch($this->dtdtype)
			{
				case "INTERNAL":
					if(!strcmp($this->dtddefinition,""))
					{
						$this->error="it was not specified a valid internal DTD definition";
						return 0;
					}
					$output.=("[".$this->linebreak.$this->dtddefinition.$this->linebreak."]");
					break;
				case "SYSTEM":
					if(!strcmp($this->dtdurl,""))
					{
						$this->error="it was not specified a valid system DTD url";
						return 0;
					}
					$output.="SYSTEM";
					if(strcmp($this->dtddefinition,""))
						$output.=(" \"".$this->dtddefinition."\"");
					$output.=(" \"".$this->dtdurl."\"");
					break;
				case "PUBLIC":
					if(!strcmp($this->dtddefinition,""))
					{
						$this->error="it was not specified a valid public DTD definition";
						return 0;
					}
					$output.=("PUBLIC \"".$this->dtddefinition."\"");
					if(strcmp($this->dtdurl,""))
						$output.=(" \"".$this->dtdurl."\"");
					break;
				default:
					$this->error="it was not specified a valid DTD type";
					return 0;
			}
			$output.=(">".$this->linebreak);
		}
		if(strcmp($this->stylesheet,""))
		{
			if(!strcmp($this->stylesheettype,""))
			{
				$this->error="it was not specified a valid stylesheet type";
				return 0;
			}
			$output.=("<?xml-stylesheet type=\"".$this->stylesheettype."\" href=\"".$this->stylesheet."\"?>".$this->linebreak);
		}
		return $this->GenerateTag($output,"0","");
	}

	Function AddDataNode($parent,$data)
	{
		$path=$parent.",".$this->structure[$parent]["Elements"];
		$this->structure[$path]=HtmlEntities($data);
		$this->structure[$parent]["Elements"]++;
	}

	Function ResetDocument()
	{
		$this->structure=array();
		$this->nodes=array();
		$this->tags=array();
		$this->current_node="";
	}

	Function WriteDocument(&$compiler,&$context,$filename,$output)
	{
		if(!$compiler->CreateContextOutputDirectory(dirname($filename),$context,"could not create XML output directory"))
			return(0);
		if(!($file=@fopen($filename,"wb")))
			return($compiler->SetElementError($context->file,$context->path,"could not open XML document for writing to the output file"));
		if(!(@fwrite($file,$output))
		|| !fflush($file))
			return($compiler->SetElementError($context->file,$context->path,"could not write to the XML document output file"));
		fclose($file);
		$context->result[]=array(
			"Data"=>array(
				"Name"=>$filename,
				"Type"=>"GENERATED"
			),
			"Type"=>"FILE"
		);
		return(1);
	}

	Function ProcessTemplate(&$compiler, &$context, &$template_context, &$template_parser, $parent_node, &$variables, &$conditional, &$in_conditional, &$tags, $options)
	{
		$this->processing_template++;
		if(!(IsSet($options["OmitTag"]) ? $options["OmitTag"] : 0))
		{
			$path=(strlen($parent_node) ? $parent_node.",".$this->structure[$parent_node]["Elements"] : "0");
	   if(IsSet($options["Node"]))
				$this->nodes[$options["Node"]]=$path;
			$this->structure[$path]=array(
				"Tag"=>(IsSet($options["Tag"]) ? $options["Tag"] : $template_parser->structure[$template_context->path]["Tag"]),
				"Attributes"=>(IsSet($options["Attributes"]) ? $options["Attributes"] : array()),
				"Indent"=>(IsSet($options["Indent"]) ? $options["Indent"] : 0),
				"Spacing"=>(IsSet($options["Spacing"]) ? $options["Spacing"] : 0),
				"Elements"=>0
			);
			$this->tags[$path]=1;
			$this->structure[$parent_node]["Elements"]++;
		}
		else
			$path=$parent_node;
		$parent_path=$template_context->path;
		$elements=$template_parser->structure[$template_context->path]["Elements"];
		for($element=0;$element<$elements;$element++)
		{
			$element_path=$parent_path.",$element";
			$data=$template_parser->structure[$element_path];
			if(GetType($data)=="array")
			{
				$tag=$data["Tag"];
				if($tag[0]=="_"
				&& $tag[$end=strlen($tag)-1]=="_")
				{
					$variable=substr($tag,1,$end-1);
					if(IsSet($variables[$variable]))
					{
						$current_node=$this->current_node;
						$this->current_node=$path;
						for($value=0;$value<count($variables[$variable]);$value++)
						{
							if(!$this->ComposeDocumentElement($compiler, $context, $variables[$variable][$value]))
								return(0);
						}
						$this->current_node=$current_node;
					}
					elseif(IsSet($conditional[$variable]))
					{
						if(IsSet($in_conditional[$variable]))
						{
							$current_node=$this->current_node;
							$this->current_node=$path;
							for($value=0;$value<count($conditional[$variable]);$value++)
							{
								if(!$this->ComposeDocumentElement($compiler, $context, $conditional[$variable][$value]))
									return(0);
							}
							$this->current_node=$current_node;
						}
						else
						{
							if(count($conditional[$variable]))
							{
								$in_conditional[$variable]=1;
								$template_context->path=$element_path;
								$tag_options=array("OmitTag"=>1);
								if(IsSet($options["Indent"]))
									$tag_options["Indent"]=$options["Indent"];
								if(IsSet($options["Spacing"]))
									$tag_options["Spacing"]=$options["Spacing"];
								if(IsSet($options["Attributes"]))
									$tag_options["Attributes"]=$options["Attributes"];
								if(!$this->ProcessTemplate($compiler, $context, $template_context, $template_parser, $path, $variables, $conditional, $in_conditional, $tags, $tag_options))
									return(0);
								Unset($in_conditional[$variable]);
							}
						}
					}
					elseif(IsSet($tags[$variable]))
					{
						$template_context->path=$element_path;
						if(IsSet($tags[$variable]["Parent"]))
							$this->nodes[$tags[$variable]["Parent"]]=$path;
						$tag_options=array();
						if(IsSet($tags[$variable]["Tag"]))
						{
							$tag_options["Tag"]=$tags[$variable]["Tag"];
							if(IsSet($tags[$variable]["Node"]))
								$tag_options["Node"]=$tags[$variable]["Node"];
						}
						else
 							$tag_options["OmitTag"]=1;
						if(IsSet($tags[$variable]["Indent"]))
							$tag_options["Indent"]=$tags[$variable]["Indent"];
						if(IsSet($tags[$variable]["Spacing"]))
							$tag_options["Spacing"]=$tags[$variable]["Spacing"];
						if(IsSet($tags[$variable]["Attributes"]))
							$tag_options["Attributes"]=$tags[$variable]["Attributes"];
						if(!$this->ProcessTemplate($compiler, $context, $template_context, $template_parser, $path, $variables, $conditional, $in_conditional, $tags, $tag_options))
							return(0);
					}
					else
						return($compiler->SetElementError($template_context->file,$element_path,"it was used the template tag ".$variable." that is not defined"));
				}
				else
				{
					$template_context->path=$element_path;
					if(!$this->ProcessTemplate($compiler, $context, $template_context, $template_parser, $path, $variables, $conditional, $in_conditional, $tags, array()))
						return(0);
				}
			}
			else
				$this->AddDataNode($path,$data);
		}
		$template_context->path=$parent_path;
		if(--$this->processing_template==0)
			$this->node_map=array();
		return(1);
	}

	Function ComposeDocumentElement(&$compiler, &$context, &$element)
	{
		switch($element["Type"])
		{
			case "XMLFILE":
				if(strlen($this->output_file))
				{
					if(!$this->GenerateDocument($output))
						return($compiler->SetElementError($context->file,$context->path,$this->error));
					if(!$this->WriteDocument($compiler,$context,$this->output_file,$output))
						return(0);
					$this->ResetDocument();
				}
				$this->output_file=$element["Data"]["File"];
				break;
			case "XMLTAG":
				if(IsSet($element["Data"]["Parent"])
				&& $element["Data"]["Parent"])
				{
					$node=$element["Data"]["Parent"];
					if($this->processing_template
					&& IsSet($this->node_map[$node]))
						$node=$this->node_map[$node];
					if(!IsSet($this->nodes[$node]))
						return($compiler->SetElementError($context->file,$context->path,"it was specified a parent node for a XMLTAG that is not defined"));
					$parent=$this->nodes[$node];
				}
				else
				{
					if(strlen($this->current_node))
						$parent=$this->current_node;
					else
						$parent="";
				}
				$path=(strlen($parent) ? $parent.",".$this->structure[$parent]["Elements"] : "0");
				if(IsSet($element["Data"]["Node"]))
				{
					$node=$element["Data"]["Node"];
					if(IsSet($this->nodes[$node]))
						return($compiler->SetElementError($context->file,$context->path,"it was specified an already defined node for the XMLTAG ".$element["Data"]["Tag"]));
					if($this->processing_template)
					{
						$mapped=$compiler->GetXMLNode();
						$this->node_map[$node]=$mapped;
						$node=$mapped;
					}
					$this->nodes[$node]=$path;
				}
				$this->structure[$path]=array(
					"Tag"=>$element["Data"]["Tag"],
					"Attributes"=>(IsSet($element["Data"]["Attributes"]) ? $element["Data"]["Attributes"] : array()),
					"Indent"=>(IsSet($element["Data"]["Indent"]) && $element["Data"]["Indent"]),
					"Spacing"=>(IsSet($element["Data"]["Spacing"]) ? $element["Data"]["Spacing"] : 0),
					"Elements"=>0
				);
				if(strlen($parent))
					$this->structure[$parent]["Elements"]++;
				$this->current_node=$path;
				$this->tags[$path]=1;
				if(IsSet($element["Data"]["Data"]))
					$this->AddDataNode($path,$element["Data"]["Data"]);
				break;
			case "XMLDATA":
				if(IsSet($element["Data"]["Parent"])
				&& $element["Data"]["Parent"])
				{
					$node=$element["Data"]["Parent"];
					if($this->processing_template
					&& IsSet($this->node_map[$node]))
						$node=$this->node_map[$node];
					if(!IsSet($this->nodes[$node]))
						return($compiler->SetElementError($context->file,$context->path,"it was specified a parent node for XMLDATA that is not defined"));
					$parent=$this->nodes[$node];
				}
				else
				{
					if(strlen($this->current_node)==0)
						return($compiler->SetElementError($context->file,$context->path,"it was specified data before specifying any document XML tag"));
					$parent=$this->current_node;
				}
				$this->AddDataNode($parent,$element["Data"]["Data"]);
				break;
			case "DATA":
				if(strlen($this->current_node)==0)
					return($compiler->SetElementError($context->file,$context->path,"it was specified data before specifying any document XML tag"));
				$this->AddDataNode($this->current_node,$element["Data"]);
				break;
			case "FILE":
				$context->result[]=$element;
				break;
			case "XMLTEMPLATE":
				$template_file=$element["Data"]["TemplateFile"];
				if(!$compiler->ParseDefinitionFile($template_file))
					return(0);
				$compiler->CreateFileContext($template_context,$template_file);
				$compiler->GetParser($template_parser,$template_file);
				if(IsSet($element["Data"]["Parent"])
				&& $element["Data"]["Parent"])
				{
					$node=$element["Data"]["Parent"];
					if($this->processing_template
					&& IsSet($this->node_map[$node]))
						$node=$this->node_map[$node];
					if(!IsSet($this->nodes[$node]))
						return($compiler->SetElementError($context->file,$context->path,"it was specified a parent node for a XMLTEMPLATE that is not defined"));
					$parent=$this->nodes[$node];
				}
				else
				{
					if(strlen($this->current_node))
						$parent=$this->current_node;
					else
						$parent="";
				}
				$variables=(IsSet($element["Data"]["Variables"]) ? $element["Data"]["Variables"] : array());
				$conditional=(IsSet($element["Data"]["Conditional"]) ? $element["Data"]["Conditional"] : array());
				$tags=(IsSet($element["Data"]["Tags"]) ? $element["Data"]["Tags"] : array());
				$options=$in_conditional=array();
				$tag=$template_parser->structure[$template_context->path]["Tag"];
				if($tag[0]=="_"
				&& $tag[$end=strlen($tag)-1]=="_")
				{
					$variable=substr($tag,1,$end-1);
					if(IsSet($tags[$variable]["Tag"]))
						$options["Tag"]=$tags[$variable]["Tag"];
					if(IsSet($tags[$variable]["Node"]))
						$options["Node"]=$tags[$variable]["Node"];
					if(IsSet($tags[$variable]["Indent"]))
						$options["Indent"]=$tags[$variable]["Indent"];
					if(IsSet($tags[$variable]["Spacing"]))
						$options["Spacing"]=$tags[$variable]["Spacing"];
					if(IsSet($tags[$variable]["Attributes"]))
						$options["Attributes"]=$tags[$variable]["Attributes"];
				}
				if(!$this->ProcessTemplate($compiler, $context, $template_context, $template_parser, $parent, $variables, $conditional, $in_conditional, $tags, $options))
					return(0);
				$context->result[]=array(
					"Data"=>array(
						"Name"=>$compiler->GetIncludePath($template_file).$template_file,
						"Type"=>"DEPENDENCY"
					),
					"Type"=>"FILE"
				);
				break;
			default:
				return($compiler->SetElementError($context->file,$context->path,$element["Type"]." is not a supported xml document part type"));
		}
		return(1);
	}
	
	Function ComposeDocument(&$compiler,&$context,&$document_context)
	{
		if(!$compiler->GetOutputData($document_context->file,$document_context->path,$result,"invalid xml document",1))
			return(0);
		$parts=count($result);
		for($part=0;$part<$parts;$part++)
		{
			if(!$this->ComposeDocumentElement($compiler, $context, $result[$part]))
				return(0);
		}
		return(1);
	}

	Function Execute(&$compiler,&$code,$function,&$context,&$arguments_code,&$arguments)
	{
		switch($function)
		{
			case "resetdocument":
				$this->ResetDocument();
				break;
			case "composedocument":
				if(!$this->ComposeDocument($compiler,$context,$context))
					return(0);
				break;
			case "generatedocument":
				$values=array(
				);
				$types=array(
				);
				$optional_types=array(
					"indentation"=>"DATA",
					"linebreak"=>"DATA",
					"from"=>"CONTEXT",
					"output"=>"DATA"
				);
				if(!$compiler->GetOptionalArgumentValues($arguments,$values,$types,$optional_types,"xml",$function,0)
				|| !$compiler->GetOptionalArgumentValues($context,$values,$types,$optional_types,"xml",$function,1))
					return(0);
				if(IsSet($values["indentation"]))
					$this->indenttext=$values["indentation"];
				if(IsSet($values["linebreak"]))
					$this->linebreak=$values["linebreak"];
				$this->output_file=(IsSet($values["output"]) ? $values["output"] : "");
				if(IsSet($values["from"]))
				{
					$this->ResetDocument();
					if(!$this->ComposeDocument($compiler,$context,$values["from"]))
						return(0);
				}
				if(strlen($this->output_file)==0)
					return($compiler->SetElementError($context->file,$context->path,"it was not specified the xml object generatedocument output argument"));
				if(!$this->GenerateDocument($output))
					return($compiler->SetElementError($context->file,$context->path,$this->error));
				if(!$this->WriteDocument($compiler,$context,$this->output_file,$output))
					return(0);
				break;
			default:
				return($compiler->SetElementError($context->file,$context->path,$function." is not a supported xml object function"));
		}
		return(1);
	}

};

}
?>