<?php
if(!defined("METAL_PERL_CLASS_BINDINGS_INCLUDED"))
{
	define("METAL_PERL_CLASS_BINDINGS_INCLUDED",1);

/*
 * perl_class.php
 *
 * @(#) $Header: /opt2/ena/metal/metal/perl_class.php,v 1.5 2003/10/10 17:15:32 mlemos Exp $
 *
 */
 
class perl_class_class extends metal_language_bindings_class
{
	Function GenerateComment(&$compiler,$comment,&$result)
	{
		for($line=$comment;strcmp($line,"");)
		{
			$line=$compiler->strtok($line,"\r\n");
			$result[]=array(
				"Data"=>" * $line",
				"Type"=>"COMMAND"
			);
			$line=$compiler->strtok("");
		}
	}

	Function GenerateVariables(&$module,&$result,$class,$protected)
	{
		for($output_variable=0,Reset($module->classes[$class]["variables"]),$function=0;$function<count($module->classes[$class]["variables"]);$function++,Next($module->classes[$class]["variables"]))
		{
			$name=Key($module->classes[$class]["variables"]);
			if(($protected
			&& IsSet($module->classes[$class]["variables"][$name]["protected"]))
			|| (!$protected
			&& !IsSet($module->classes[$class]["variables"][$name]["protected"])))
			{
				if($output_variable==0)
				{
					if(!$protected)
					{
						$result[]=array(
							"Data"=>"",
							"Type"=>"COMMAND"
						);
					}
					$result[]=array(
						"Data"=>"/*",
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" * ".($protected ? "Protected variables" : "Public variables"),
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" */",
						"Type"=>"COMMAND"
					);
				}
				$value=(IsSet($module->classes[$class]["variables"][$name]["value"]) ? "=".$module->classes[$class]["variables"][$name]["convertedvalue"] : "");
				$result[]=array(
					"Data"=>"var \$$name$value;",
					"Type"=>"COMMAND"
				);
				$output_variable++;
			}
		}
	}

	Function GenerateFunctions(&$module,&$compiler,&$result,$class,$protected)
	{
		for($output_function=0,Reset($module->classes[$class]["functions"]),$function=0;$function<count($module->classes[$class]["functions"]);$function++,Next($module->classes[$class]["functions"]))
		{
			$name=Key($module->classes[$class]["functions"]);
			if(($protected
			&& IsSet($module->classes[$class]["functions"][$name]["protected"]))
			|| (!$protected
			&& !IsSet($module->classes[$class]["functions"][$name]["protected"])))
			{
				$result[]=array(
					"Data"=>"",
					"Type"=>"COMMAND"
				);
				if($output_function==0)
				{
					$result[]=array(
						"Data"=>"/*",
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" * ".($protected ? "Protected functions" : "Public functions"),
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					$result[]=array(
						"Data"=>" */",
						"Type"=>"COMMAND"
					);
				}
				if(!$module->GenerateFunction($compiler,$class,$name))
					return(0);
				$argument_list="";
				if(IsSet($module->classes[$class]["functions"][$name]["Arguments"]))
				{
					$arguments=$module->classes[$class]["functions"][$name]["Arguments"];
					for(Reset($arguments),$argument=0;$argument<count($arguments);Next($arguments),$argument++)
					{
						if($argument>0)
							$argument_list.=",";
						$argument_list.=(IsSet($arguments[Key($arguments)]["reference"]) ? "&" : "")."\$".Key($arguments);
					}
				}
				$result[]=array(
					"Data"=>"Function $name($argument_list)",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$result[]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				for($part=0;$part<count($module->classes[$class]["functions"][$name]["do"]["code"]);$part++)
				{
					if(strcmp($module->classes[$class]["functions"][$name]["do"]["code"][$part]["Type"],"INITIALIZATION"))
						$result[]=$module->classes[$class]["functions"][$name]["do"]["code"][$part];
					else
						$initialization_result[]=$module->classes[$class]["functions"][$name]["do"]["code"][$part];
				}
				$result[]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$result[]=array(
					"Data"=>"}",
					"Type"=>"COMMAND"
				);
				$output_function++;
			}
		}
		return(1);
	}

	Function Execute(&$compiler,&$context,&$class,$function,&$message)
	{
		switch($function)
		{
			case "output":
				$message["result"]=array();
				$message["result"][]=array(
					"Data"=>0,
					"Type"=>"RESETINDENT"
				);
				if(strcmp($class->classes[$message["class"]]["file"],""))
				{
					if(!IsSet($class->classes[$message["class"]]["tag"]))
						$class->classes[$message["class"]]["tag"]="CLASS_".strtoupper(ereg_replace("[^A-Za-z0-9]","_",$class->classes[$message["class"]]["file"]));
					$message["result"][]=array(
						"Data"=>"if(!defined(\"".$class->classes[$message["class"]]["tag"]."\"))",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>"{",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>1,
						"Type"=>"INDENT"
					);
					$message["result"][]=array(
						"Data"=>"define(\"".$class->classes[$message["class"]]["tag"]."\",1);",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>1,
						"Type"=>"OUTDENT"
					);
				}
				$message["result"][]=array(
					"Data"=>"",
					"Type"=>"COMMAND"
				);
				if(IsSet($class->classes[$message["class"]]["comment"])
				|| IsSet($class->classes[$message["class"]]["copyright"]))
				{
					$message["result"][]=array(
						"Data"=>"/*",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					if(IsSet($class->classes[$message["class"]]["copyright"]))
					{
						$this->GenerateComment($compiler,$class->classes[$message["class"]]["copyright"],$message["result"]);
						if(IsSet($class->classes[$message["class"]]["comment"]))
						{
							$message["result"][]=array(
								"Data"=>" *",
								"Type"=>"COMMAND"
							);
						}
					}
					if(IsSet($class->classes[$message["class"]]["comment"]))
						$this->GenerateComment($compiler,$class->classes[$message["class"]]["comment"],$message["result"]);
					$message["result"][]=array(
						"Data"=>" *",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>" */",
						"Type"=>"COMMAND"
					);
					$message["result"][]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				$message["result"][]=array(
					"Data"=>"class ".$class->classes[$message["class"]]["name"].(IsSet($class->classes[$message["class"]]["parent"]) ? " extends ".$class->classes[$class->classes[$message["class"]]["parent"]]["name"] : ""),
					"Type"=>"COMMAND"
				);
				$message["result"][]=array(
					"Data"=>"{",
					"Type"=>"COMMAND"
				);
				$message["result"][]=array(
					"Data"=>1,
					"Type"=>"INDENT"
				);
				$this->GenerateVariables($class,$message["result"],$message["class"],1);
				$this->GenerateVariables($class,$message["result"],$message["class"],0);
				if(count($class->classes[$message["class"]]["variables"])
				&& count($class->classes[$message["class"]]["functions"]))
				{
					$message["result"][]=array(
						"Data"=>"",
						"Type"=>"COMMAND"
					);
				}
				if(!$this->GenerateFunctions($class,$compiler,$message["result"],$message["class"],1)
				|| !$this->GenerateFunctions($class,$compiler,$message["result"],$message["class"],0))
					return(0);
				$message["result"][]=array(
					"Data"=>1,
					"Type"=>"OUTDENT"
				);
				$message["result"][]=array(
					"Data"=>"};",
					"Type"=>"COMMAND"
				);
				$message["result"][]=array(
					"Data"=>"",
					"Type"=>"COMMAND"
				);
				if(strcmp($class->classes[$message["class"]]["file"],""))
				{
					$message["result"][]=array(
						"Data"=>"}",
						"Type"=>"COMMAND"
					);
				}
				$message["result"][]=array(
					"Data"=>0,
					"Type"=>"RESTOREINDENT"
				);
				break;
			default:
				$compiler->SetElementError($context->file,$context->path,"bindings for function \"$function\" are not implemented for language ".$compiler->language["name"]);
				return(0);
		}
		return(1);
	}
};
 
}
?>